
/*
 * This is an auto-generated file.
 * Do not edit! All changes made to it will be lost.
 */


#include <entities.h>
#include <storage/datastore.h>

#include <qsqldatabase.h>
#include <QLatin1String>
#include <qsqlquery.h>
#include <qsqlerror.h>
#include <qvariant.h>
#include <QtCore/QHash>
#include <QtCore/QMutex>

using namespace Akonadi;



// private class
class SchemaVersion::Private : public QSharedData
{
  public:
    Private() : QSharedData() {}
    Private( const Private & other ) : QSharedData( other )
    {
      version = other.version;
      version_changed = other.version_changed;
      
    }
    ~Private() {};

    int version;
    bool version_changed;
    

    static void addToCache( const SchemaVersion & entry );

    // cache
    static bool cacheEnabled;
    static QMutex cacheMutex;
    
};


// static members
bool SchemaVersion::Private::cacheEnabled = false;
QMutex SchemaVersion::Private::cacheMutex;



void SchemaVersion::Private::addToCache( const SchemaVersion & entry )
{
  Q_ASSERT( cacheEnabled );
  cacheMutex.lock();
  
  cacheMutex.unlock();
}


// constructor
SchemaVersion::SchemaVersion() : Entity(),
  d( new Private )
{

  d->version_changed = false;

}

SchemaVersion::SchemaVersion(
  int version
) :
  Entity(),
  d( new Private )
{

  d->version = version;
  d->version_changed = true;

}

SchemaVersion::SchemaVersion( const SchemaVersion & other )
  : Entity( other ), d( other.d )
{
}

// destructor
SchemaVersion::~SchemaVersion() {}

// assignment operator
SchemaVersion& SchemaVersion::operator=( const SchemaVersion & other )
{
  if ( this != &other ) {
    d = other.d;
    setId( other.id() );
  }
  return *this;
}

// accessor methods
int SchemaVersion::version() const
{
  return d->version;
}

void SchemaVersion::
setVersion( int version )

{
  d->version = version;
  d->version_changed = true;
}



// SQL table information
QString SchemaVersion::tableName()
{
  return QLatin1String( "SchemaVersionTable" );
}

QStringList SchemaVersion::columnNames()
{
  QStringList rv;
  
  rv.append( QLatin1String( "version" ) );
  
  return rv;
}

QStringList SchemaVersion::fullColumnNames()
{
  QStringList rv;
  
  rv.append( QLatin1String( "SchemaVersionTable.version" ) );
  
  return rv;
}


QString SchemaVersion::versionColumn()
{
  return QLatin1String( "version" );
}

QString SchemaVersion::versionFullColumnName()
{
  return tableName() + QLatin1String( ".version" );
}



// count records
int SchemaVersion::count( const QString &column, const QVariant &value )
{
  return Entity::count<SchemaVersion>( column, value );
}

// check existence



// result extraction
QList< SchemaVersion > SchemaVersion::extractResult( QSqlQuery & query )
{
  QList<SchemaVersion> rv;
  while ( query.next() ) {
    rv.append( SchemaVersion(
      
        query.value( 0 ).value<int>()
        
    ) );
  }
  return rv;
}

// data retrieval


QList<SchemaVersion> SchemaVersion::retrieveAll()
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QList<SchemaVersion>();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT version FROM " );
  statement.append( tableName() );
  query.prepare( statement );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of all records from table" << tableName()
      << query.lastError().text();
    return QList<SchemaVersion>();
  }
  return extractResult( query );
}

QList<SchemaVersion> SchemaVersion::retrieveFiltered( const QString &key, const QVariant &value )
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QList<SchemaVersion>();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT version FROM " );
  statement.append( tableName() );
  statement.append( QLatin1String(" WHERE ") );
  statement.append( key );
  statement.append( QLatin1String(" = :key") );
  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), value );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of records from table" << tableName()
      << "filtered by" << key << "=" << value
      << query.lastError().text();
    return QList<SchemaVersion>();
  }
  return extractResult( query );
}

// data retrieval for referenced tables


// data retrieval for inverse referenced tables


// debug stream operator
QDebug & operator<<( QDebug& d, const SchemaVersion& entity )
{
  d << "[SchemaVersion: "
  
    << "version = " << entity.version()
    
    << "]";
  return d;
}

// inserting new data
bool SchemaVersion::insert( qint64* insertId )
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return false;

  QStringList cols, vals;
  
  if ( d->version_changed ) {
    cols.append( versionColumn() );
    vals.append( QLatin1String( ":version" ) );
  }
  
  QString statement = QString::fromLatin1("INSERT INTO SchemaVersionTable (%1) VALUES (%2)")
    .arg( cols.join( QLatin1String(",") ), vals.join( QLatin1String(",") ) );

  QSqlQuery query( db );
  query.prepare( statement );
  
  if ( d->version_changed ) {
    query.bindValue( QLatin1String(":version"), this->version() );
  }
  

  if ( !query.exec() ) {
    qDebug() << "Error during insertion into table" << tableName()
      << query.lastError().text();
    return false;
  }

  setId( DataStore::self()->lastInsertId( query ) );
  if ( insertId )
    *insertId = id();
  return true;
}

// update existing data
bool SchemaVersion::update()
{
  invalidateCache();
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return false;

  QString statement = QLatin1String( "UPDATE " );
  statement += tableName();
  statement += QLatin1String( " SET " );

  QStringList cols;
  
  if ( d->version_changed )
    cols.append( versionColumn() + QLatin1String( " = :version" ) );;
  
  statement += cols.join( QLatin1String( ", " ) );
  

  QSqlQuery query( db );
  query.prepare( statement );
  
  if ( d->version_changed ) {
    query.bindValue( QLatin1String(":version"), this->version() );
  }
  
  if ( !query.exec() ) {
    qDebug() << "Error during updating record with id" << id()
             << " in table" << tableName() << query.lastError().text();
    return false;
  }
  return true;
}

// delete records
bool SchemaVersion::remove( const QString &column, const QVariant &value )
{
  invalidateCompleteCache();
  return Entity::remove<SchemaVersion>( column, value );
}



// cache stuff
void SchemaVersion::invalidateCache() const
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    
    Private::cacheMutex.unlock();
  }
}

void SchemaVersion::invalidateCompleteCache()
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    
    Private::cacheMutex.unlock();
  }
}

void SchemaVersion::enableCache( bool enable )
{
  Private::cacheEnabled = enable;
}



// private class
class Resource::Private : public QSharedData
{
  public:
    Private() : QSharedData() {}
    Private( const Private & other ) : QSharedData( other )
    {
      name = other.name;
      name_changed = other.name_changed;
      
    }
    ~Private() {};

    QString name;
    bool name_changed;
    

    static void addToCache( const Resource & entry );

    // cache
    static bool cacheEnabled;
    static QMutex cacheMutex;
    
    static QHash<qint64, Resource > idCache;
    
    static QHash<QString, Resource > nameCache;
    
};


// static members
bool Resource::Private::cacheEnabled = false;
QMutex Resource::Private::cacheMutex;

QHash<qint64, Resource > Resource::Private::idCache;

QHash<QString, Resource > Resource::Private::nameCache;



void Resource::Private::addToCache( const Resource & entry )
{
  Q_ASSERT( cacheEnabled );
  cacheMutex.lock();
  
  idCache.insert( entry.id(), entry );
  
  nameCache.insert( entry.name(), entry );
  
  cacheMutex.unlock();
}


// constructor
Resource::Resource() : Entity(),
  d( new Private )
{

  d->name_changed = false;

}

Resource::Resource(
  const QString &name
) :
  Entity(),
  d( new Private )
{

  d->name = name;
  d->name_changed = true;

}

Resource::Resource(
  qint64 id, const QString &name
) :
  Entity( id ),
  d( new Private )
{

  d->name = name;
  d->name_changed = true;

}
Resource::Resource( const Resource & other )
  : Entity( other ), d( other.d )
{
}

// destructor
Resource::~Resource() {}

// assignment operator
Resource& Resource::operator=( const Resource & other )
{
  if ( this != &other ) {
    d = other.d;
    setId( other.id() );
  }
  return *this;
}

// accessor methods
QString Resource::name() const
{
  return d->name;
}

void Resource::
setName( const QString &name )

{
  d->name = name;
  d->name_changed = true;
}



// SQL table information
QString Resource::tableName()
{
  return QLatin1String( "ResourceTable" );
}

QStringList Resource::columnNames()
{
  QStringList rv;
  
  rv.append( QLatin1String( "id" ) );
  
  rv.append( QLatin1String( "name" ) );
  
  return rv;
}

QStringList Resource::fullColumnNames()
{
  QStringList rv;
  
  rv.append( QLatin1String( "ResourceTable.id" ) );
  
  rv.append( QLatin1String( "ResourceTable.name" ) );
  
  return rv;
}


QString Resource::idColumn()
{
  return QLatin1String( "id" );
}

QString Resource::idFullColumnName()
{
  return tableName() + QLatin1String( ".id" );
}

QString Resource::nameColumn()
{
  return QLatin1String( "name" );
}

QString Resource::nameFullColumnName()
{
  return tableName() + QLatin1String( ".name" );
}



// count records
int Resource::count( const QString &column, const QVariant &value )
{
  return Entity::count<Resource>( column, value );
}

// check existence

bool Resource::exists( qint64 id )
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::idCache.contains( id ) ) {
      Private::cacheMutex.unlock();
      return true;
    }
    Private::cacheMutex.unlock();
  }
  return count( idColumn(), id ) > 0;
}

bool Resource::exists( const QString &name )
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::nameCache.contains( name ) ) {
      Private::cacheMutex.unlock();
      return true;
    }
    Private::cacheMutex.unlock();
  }
  return count( nameColumn(), name ) > 0;
}



// result extraction
QList< Resource > Resource::extractResult( QSqlQuery & query )
{
  QList<Resource> rv;
  while ( query.next() ) {
    rv.append( Resource(
      
        query.value( 0 ).value<qint64>()
        ,
        query.value( 1 ).value<QString>()
        
    ) );
  }
  return rv;
}

// data retrieval
Resource Resource::retrieveById( qint64 id )
{
  
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::idCache.contains( id ) ) {
      Private::cacheMutex.unlock();
      return Private::idCache.value( id );
    }
    Private::cacheMutex.unlock();
  }
  
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return Resource();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, name FROM " );
  statement.append( tableName() );
  statement.append( QLatin1String(" WHERE id = :key") );
  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), id );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of record with id"
      << id << "from table" << tableName()
      << query.lastError().text();
    return Resource();
  }
  if ( !query.next() ) {
    return Resource();
  }

  Resource rv(
  
    query.value( 0 ).value<qint64>()
    ,
    query.value( 1 ).value<QString>()
    
  );
  if ( Private::cacheEnabled ) {
    Private::addToCache( rv );
  }
  return rv;

}

Resource Resource::retrieveByName( const QString &name )
{
  
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::nameCache.contains( name ) ) {
      Private::cacheMutex.unlock();
      return Private::nameCache.value( name );
    }
    Private::cacheMutex.unlock();
  }
  
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return Resource();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, name FROM " );
  statement.append( tableName() );
  statement.append( QLatin1String(" WHERE name = :key") );
  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), name );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of record with name"
      << name << "from table" << tableName()
      << query.lastError().text();
    return Resource();
  }
  if ( !query.next() ) {
    return Resource();
  }

  Resource rv(
  
    query.value( 0 ).value<qint64>()
    ,
    query.value( 1 ).value<QString>()
    
  );
  if ( Private::cacheEnabled ) {
    Private::addToCache( rv );
  }
  return rv;

}


QList<Resource> Resource::retrieveAll()
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QList<Resource>();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, name FROM " );
  statement.append( tableName() );
  query.prepare( statement );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of all records from table" << tableName()
      << query.lastError().text();
    return QList<Resource>();
  }
  return extractResult( query );
}

QList<Resource> Resource::retrieveFiltered( const QString &key, const QVariant &value )
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QList<Resource>();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, name FROM " );
  statement.append( tableName() );
  statement.append( QLatin1String(" WHERE ") );
  statement.append( key );
  statement.append( QLatin1String(" = :key") );
  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), value );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of records from table" << tableName()
      << "filtered by" << key << "=" << value
      << query.lastError().text();
    return QList<Resource>();
  }
  return extractResult( query );
}

// data retrieval for referenced tables


// data retrieval for inverse referenced tables

QList<Location> Resource::locations() const
{
  return Location::retrieveFiltered( Location::resourceIdColumn(), id() );
}


// debug stream operator
QDebug & operator<<( QDebug& d, const Resource& entity )
{
  d << "[Resource: "
  
    << "id = " << entity.id()
    << ", "
    << "name = " << entity.name()
    
    << "]";
  return d;
}

// inserting new data
bool Resource::insert( qint64* insertId )
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return false;

  QStringList cols, vals;
  
  if ( d->name_changed ) {
    cols.append( nameColumn() );
    vals.append( QLatin1String( ":name" ) );
  }
  
  QString statement = QString::fromLatin1("INSERT INTO ResourceTable (%1) VALUES (%2)")
    .arg( cols.join( QLatin1String(",") ), vals.join( QLatin1String(",") ) );

  QSqlQuery query( db );
  query.prepare( statement );
  
  if ( d->name_changed ) {
    query.bindValue( QLatin1String(":name"), this->name() );
  }
  

  if ( !query.exec() ) {
    qDebug() << "Error during insertion into table" << tableName()
      << query.lastError().text();
    return false;
  }

  setId( DataStore::self()->lastInsertId( query ) );
  if ( insertId )
    *insertId = id();
  return true;
}

// update existing data
bool Resource::update()
{
  invalidateCache();
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return false;

  QString statement = QLatin1String( "UPDATE " );
  statement += tableName();
  statement += QLatin1String( " SET " );

  QStringList cols;
  
  if ( d->name_changed )
    cols.append( nameColumn() + QLatin1String( " = :name" ) );;
  
  statement += cols.join( QLatin1String( ", " ) );
  
  statement += QLatin1String( " WHERE id = :id" );
  

  QSqlQuery query( db );
  query.prepare( statement );
  
  if ( d->name_changed ) {
    query.bindValue( QLatin1String(":name"), this->name() );
  }
  
  query.bindValue( QLatin1String(":id"), id() );
  
  if ( !query.exec() ) {
    qDebug() << "Error during updating record with id" << id()
             << " in table" << tableName() << query.lastError().text();
    return false;
  }
  return true;
}

// delete records
bool Resource::remove( const QString &column, const QVariant &value )
{
  invalidateCompleteCache();
  return Entity::remove<Resource>( column, value );
}


bool Resource::remove()
{
  invalidateCache();
  return Entity::remove<Resource>( idColumn(), id() );
}

bool Resource::remove( qint64 id )
{
  return remove( idColumn(), id );
}


// cache stuff
void Resource::invalidateCache() const
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    
    Private::idCache.remove( id() );
    
    Private::nameCache.remove( name() );
    
    Private::cacheMutex.unlock();
  }
}

void Resource::invalidateCompleteCache()
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    
    Private::idCache.clear();
    
    Private::nameCache.clear();
    
    Private::cacheMutex.unlock();
  }
}

void Resource::enableCache( bool enable )
{
  Private::cacheEnabled = enable;
}



// private class
class Location::Private : public QSharedData
{
  public:
    Private() : QSharedData() {}
    Private( const Private & other ) : QSharedData( other )
    {
      remoteId = other.remoteId;
      remoteId_changed = other.remoteId_changed;
      name = other.name;
      name_changed = other.name_changed;
      parentId = other.parentId;
      parentId_changed = other.parentId_changed;
      resourceId = other.resourceId;
      resourceId_changed = other.resourceId_changed;
      subscribed = other.subscribed;
      subscribed_changed = other.subscribed_changed;
      cachePolicyInherit = other.cachePolicyInherit;
      cachePolicyInherit_changed = other.cachePolicyInherit_changed;
      cachePolicyCheckInterval = other.cachePolicyCheckInterval;
      cachePolicyCheckInterval_changed = other.cachePolicyCheckInterval_changed;
      cachePolicyCacheTimeout = other.cachePolicyCacheTimeout;
      cachePolicyCacheTimeout_changed = other.cachePolicyCacheTimeout_changed;
      cachePolicySyncOnDemand = other.cachePolicySyncOnDemand;
      cachePolicySyncOnDemand_changed = other.cachePolicySyncOnDemand_changed;
      cachePolicyLocalParts = other.cachePolicyLocalParts;
      cachePolicyLocalParts_changed = other.cachePolicyLocalParts_changed;
      
    }
    ~Private() {};

    QString remoteId;
    bool remoteId_changed;
    QByteArray name;
    bool name_changed;
    qint64 parentId;
    bool parentId_changed;
    qint64 resourceId;
    bool resourceId_changed;
    bool subscribed;
    bool subscribed_changed;
    bool cachePolicyInherit;
    bool cachePolicyInherit_changed;
    int cachePolicyCheckInterval;
    bool cachePolicyCheckInterval_changed;
    int cachePolicyCacheTimeout;
    bool cachePolicyCacheTimeout_changed;
    bool cachePolicySyncOnDemand;
    bool cachePolicySyncOnDemand_changed;
    QString cachePolicyLocalParts;
    bool cachePolicyLocalParts_changed;
    

    static void addToCache( const Location & entry );

    // cache
    static bool cacheEnabled;
    static QMutex cacheMutex;
    
    static QHash<qint64, Location > idCache;
    
    static QHash<QByteArray, Location > nameCache;
    
};


// static members
bool Location::Private::cacheEnabled = false;
QMutex Location::Private::cacheMutex;

QHash<qint64, Location > Location::Private::idCache;

QHash<QByteArray, Location > Location::Private::nameCache;



void Location::Private::addToCache( const Location & entry )
{
  Q_ASSERT( cacheEnabled );
  cacheMutex.lock();
  
  idCache.insert( entry.id(), entry );
  
  nameCache.insert( entry.name(), entry );
  
  cacheMutex.unlock();
}


// constructor
Location::Location() : Entity(),
  d( new Private )
{

  d->remoteId_changed = false;

  d->name_changed = false;

  d->parentId_changed = false;

  d->resourceId_changed = false;

  d->subscribed_changed = false;

  d->cachePolicyInherit_changed = false;

  d->cachePolicyCheckInterval_changed = false;

  d->cachePolicyCacheTimeout_changed = false;

  d->cachePolicySyncOnDemand_changed = false;

  d->cachePolicyLocalParts_changed = false;

}

Location::Location(
  const QString &remoteId, const QByteArray &name, qint64 parentId, qint64 resourceId, bool subscribed, bool cachePolicyInherit, int cachePolicyCheckInterval, int cachePolicyCacheTimeout, bool cachePolicySyncOnDemand, const QString &cachePolicyLocalParts
) :
  Entity(),
  d( new Private )
{

  d->remoteId = remoteId;
  d->remoteId_changed = true;

  d->name = name;
  d->name_changed = true;

  d->parentId = parentId;
  d->parentId_changed = true;

  d->resourceId = resourceId;
  d->resourceId_changed = true;

  d->subscribed = subscribed;
  d->subscribed_changed = true;

  d->cachePolicyInherit = cachePolicyInherit;
  d->cachePolicyInherit_changed = true;

  d->cachePolicyCheckInterval = cachePolicyCheckInterval;
  d->cachePolicyCheckInterval_changed = true;

  d->cachePolicyCacheTimeout = cachePolicyCacheTimeout;
  d->cachePolicyCacheTimeout_changed = true;

  d->cachePolicySyncOnDemand = cachePolicySyncOnDemand;
  d->cachePolicySyncOnDemand_changed = true;

  d->cachePolicyLocalParts = cachePolicyLocalParts;
  d->cachePolicyLocalParts_changed = true;

}

Location::Location(
  qint64 id, const QString &remoteId, const QByteArray &name, qint64 parentId, qint64 resourceId, bool subscribed, bool cachePolicyInherit, int cachePolicyCheckInterval, int cachePolicyCacheTimeout, bool cachePolicySyncOnDemand, const QString &cachePolicyLocalParts
) :
  Entity( id ),
  d( new Private )
{

  d->remoteId = remoteId;
  d->remoteId_changed = true;

  d->name = name;
  d->name_changed = true;

  d->parentId = parentId;
  d->parentId_changed = true;

  d->resourceId = resourceId;
  d->resourceId_changed = true;

  d->subscribed = subscribed;
  d->subscribed_changed = true;

  d->cachePolicyInherit = cachePolicyInherit;
  d->cachePolicyInherit_changed = true;

  d->cachePolicyCheckInterval = cachePolicyCheckInterval;
  d->cachePolicyCheckInterval_changed = true;

  d->cachePolicyCacheTimeout = cachePolicyCacheTimeout;
  d->cachePolicyCacheTimeout_changed = true;

  d->cachePolicySyncOnDemand = cachePolicySyncOnDemand;
  d->cachePolicySyncOnDemand_changed = true;

  d->cachePolicyLocalParts = cachePolicyLocalParts;
  d->cachePolicyLocalParts_changed = true;

}
Location::Location( const Location & other )
  : Entity( other ), d( other.d )
{
}

// destructor
Location::~Location() {}

// assignment operator
Location& Location::operator=( const Location & other )
{
  if ( this != &other ) {
    d = other.d;
    setId( other.id() );
  }
  return *this;
}

// accessor methods
QString Location::remoteId() const
{
  return d->remoteId;
}

void Location::
setRemoteId( const QString &remoteId )

{
  d->remoteId = remoteId;
  d->remoteId_changed = true;
}

QByteArray Location::name() const
{
  return d->name;
}

void Location::
setName( const QByteArray &name )

{
  d->name = name;
  d->name_changed = true;
}

qint64 Location::parentId() const
{
  return d->parentId;
}

void Location::
setParentId( qint64 parentId )

{
  d->parentId = parentId;
  d->parentId_changed = true;
}

qint64 Location::resourceId() const
{
  return d->resourceId;
}

void Location::
setResourceId( qint64 resourceId )

{
  d->resourceId = resourceId;
  d->resourceId_changed = true;
}

bool Location::subscribed() const
{
  return d->subscribed;
}

void Location::
setSubscribed( bool subscribed )

{
  d->subscribed = subscribed;
  d->subscribed_changed = true;
}

bool Location::cachePolicyInherit() const
{
  return d->cachePolicyInherit;
}

void Location::
setCachePolicyInherit( bool cachePolicyInherit )

{
  d->cachePolicyInherit = cachePolicyInherit;
  d->cachePolicyInherit_changed = true;
}

int Location::cachePolicyCheckInterval() const
{
  return d->cachePolicyCheckInterval;
}

void Location::
setCachePolicyCheckInterval( int cachePolicyCheckInterval )

{
  d->cachePolicyCheckInterval = cachePolicyCheckInterval;
  d->cachePolicyCheckInterval_changed = true;
}

int Location::cachePolicyCacheTimeout() const
{
  return d->cachePolicyCacheTimeout;
}

void Location::
setCachePolicyCacheTimeout( int cachePolicyCacheTimeout )

{
  d->cachePolicyCacheTimeout = cachePolicyCacheTimeout;
  d->cachePolicyCacheTimeout_changed = true;
}

bool Location::cachePolicySyncOnDemand() const
{
  return d->cachePolicySyncOnDemand;
}

void Location::
setCachePolicySyncOnDemand( bool cachePolicySyncOnDemand )

{
  d->cachePolicySyncOnDemand = cachePolicySyncOnDemand;
  d->cachePolicySyncOnDemand_changed = true;
}

QString Location::cachePolicyLocalParts() const
{
  return d->cachePolicyLocalParts;
}

void Location::
setCachePolicyLocalParts( const QString &cachePolicyLocalParts )

{
  d->cachePolicyLocalParts = cachePolicyLocalParts;
  d->cachePolicyLocalParts_changed = true;
}



// SQL table information
QString Location::tableName()
{
  return QLatin1String( "LocationTable" );
}

QStringList Location::columnNames()
{
  QStringList rv;
  
  rv.append( QLatin1String( "id" ) );
  
  rv.append( QLatin1String( "remoteId" ) );
  
  rv.append( QLatin1String( "name" ) );
  
  rv.append( QLatin1String( "parentId" ) );
  
  rv.append( QLatin1String( "resourceId" ) );
  
  rv.append( QLatin1String( "subscribed" ) );
  
  rv.append( QLatin1String( "cachePolicyInherit" ) );
  
  rv.append( QLatin1String( "cachePolicyCheckInterval" ) );
  
  rv.append( QLatin1String( "cachePolicyCacheTimeout" ) );
  
  rv.append( QLatin1String( "cachePolicySyncOnDemand" ) );
  
  rv.append( QLatin1String( "cachePolicyLocalParts" ) );
  
  return rv;
}

QStringList Location::fullColumnNames()
{
  QStringList rv;
  
  rv.append( QLatin1String( "LocationTable.id" ) );
  
  rv.append( QLatin1String( "LocationTable.remoteId" ) );
  
  rv.append( QLatin1String( "LocationTable.name" ) );
  
  rv.append( QLatin1String( "LocationTable.parentId" ) );
  
  rv.append( QLatin1String( "LocationTable.resourceId" ) );
  
  rv.append( QLatin1String( "LocationTable.subscribed" ) );
  
  rv.append( QLatin1String( "LocationTable.cachePolicyInherit" ) );
  
  rv.append( QLatin1String( "LocationTable.cachePolicyCheckInterval" ) );
  
  rv.append( QLatin1String( "LocationTable.cachePolicyCacheTimeout" ) );
  
  rv.append( QLatin1String( "LocationTable.cachePolicySyncOnDemand" ) );
  
  rv.append( QLatin1String( "LocationTable.cachePolicyLocalParts" ) );
  
  return rv;
}


QString Location::idColumn()
{
  return QLatin1String( "id" );
}

QString Location::idFullColumnName()
{
  return tableName() + QLatin1String( ".id" );
}

QString Location::remoteIdColumn()
{
  return QLatin1String( "remoteId" );
}

QString Location::remoteIdFullColumnName()
{
  return tableName() + QLatin1String( ".remoteId" );
}

QString Location::nameColumn()
{
  return QLatin1String( "name" );
}

QString Location::nameFullColumnName()
{
  return tableName() + QLatin1String( ".name" );
}

QString Location::parentIdColumn()
{
  return QLatin1String( "parentId" );
}

QString Location::parentIdFullColumnName()
{
  return tableName() + QLatin1String( ".parentId" );
}

QString Location::resourceIdColumn()
{
  return QLatin1String( "resourceId" );
}

QString Location::resourceIdFullColumnName()
{
  return tableName() + QLatin1String( ".resourceId" );
}

QString Location::subscribedColumn()
{
  return QLatin1String( "subscribed" );
}

QString Location::subscribedFullColumnName()
{
  return tableName() + QLatin1String( ".subscribed" );
}

QString Location::cachePolicyInheritColumn()
{
  return QLatin1String( "cachePolicyInherit" );
}

QString Location::cachePolicyInheritFullColumnName()
{
  return tableName() + QLatin1String( ".cachePolicyInherit" );
}

QString Location::cachePolicyCheckIntervalColumn()
{
  return QLatin1String( "cachePolicyCheckInterval" );
}

QString Location::cachePolicyCheckIntervalFullColumnName()
{
  return tableName() + QLatin1String( ".cachePolicyCheckInterval" );
}

QString Location::cachePolicyCacheTimeoutColumn()
{
  return QLatin1String( "cachePolicyCacheTimeout" );
}

QString Location::cachePolicyCacheTimeoutFullColumnName()
{
  return tableName() + QLatin1String( ".cachePolicyCacheTimeout" );
}

QString Location::cachePolicySyncOnDemandColumn()
{
  return QLatin1String( "cachePolicySyncOnDemand" );
}

QString Location::cachePolicySyncOnDemandFullColumnName()
{
  return tableName() + QLatin1String( ".cachePolicySyncOnDemand" );
}

QString Location::cachePolicyLocalPartsColumn()
{
  return QLatin1String( "cachePolicyLocalParts" );
}

QString Location::cachePolicyLocalPartsFullColumnName()
{
  return tableName() + QLatin1String( ".cachePolicyLocalParts" );
}



// count records
int Location::count( const QString &column, const QVariant &value )
{
  return Entity::count<Location>( column, value );
}

// check existence

bool Location::exists( qint64 id )
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::idCache.contains( id ) ) {
      Private::cacheMutex.unlock();
      return true;
    }
    Private::cacheMutex.unlock();
  }
  return count( idColumn(), id ) > 0;
}

bool Location::exists( const QByteArray &name )
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::nameCache.contains( name ) ) {
      Private::cacheMutex.unlock();
      return true;
    }
    Private::cacheMutex.unlock();
  }
  return count( nameColumn(), name ) > 0;
}



// result extraction
QList< Location > Location::extractResult( QSqlQuery & query )
{
  QList<Location> rv;
  while ( query.next() ) {
    rv.append( Location(
      
        query.value( 0 ).value<qint64>()
        ,
        query.value( 1 ).value<QString>()
        ,
        query.value( 2 ).value<QByteArray>()
        ,
        query.value( 3 ).value<qint64>()
        ,
        query.value( 4 ).value<qint64>()
        ,
        query.value( 5 ).value<bool>()
        ,
        query.value( 6 ).value<bool>()
        ,
        query.value( 7 ).value<int>()
        ,
        query.value( 8 ).value<int>()
        ,
        query.value( 9 ).value<bool>()
        ,
        query.value( 10 ).value<QString>()
        
    ) );
  }
  return rv;
}

// data retrieval
Location Location::retrieveById( qint64 id )
{
  
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::idCache.contains( id ) ) {
      Private::cacheMutex.unlock();
      return Private::idCache.value( id );
    }
    Private::cacheMutex.unlock();
  }
  
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return Location();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, remoteId, name, parentId, resourceId, subscribed, cachePolicyInherit, cachePolicyCheckInterval, cachePolicyCacheTimeout, cachePolicySyncOnDemand, cachePolicyLocalParts FROM " );
  statement.append( tableName() );
  statement.append( QLatin1String(" WHERE id = :key") );
  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), id );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of record with id"
      << id << "from table" << tableName()
      << query.lastError().text();
    return Location();
  }
  if ( !query.next() ) {
    return Location();
  }

  Location rv(
  
    query.value( 0 ).value<qint64>()
    ,
    query.value( 1 ).value<QString>()
    ,
    query.value( 2 ).value<QByteArray>()
    ,
    query.value( 3 ).value<qint64>()
    ,
    query.value( 4 ).value<qint64>()
    ,
    query.value( 5 ).value<bool>()
    ,
    query.value( 6 ).value<bool>()
    ,
    query.value( 7 ).value<int>()
    ,
    query.value( 8 ).value<int>()
    ,
    query.value( 9 ).value<bool>()
    ,
    query.value( 10 ).value<QString>()
    
  );
  if ( Private::cacheEnabled ) {
    Private::addToCache( rv );
  }
  return rv;

}

Location Location::retrieveByName( const QByteArray &name )
{
  
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::nameCache.contains( name ) ) {
      Private::cacheMutex.unlock();
      return Private::nameCache.value( name );
    }
    Private::cacheMutex.unlock();
  }
  
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return Location();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, remoteId, name, parentId, resourceId, subscribed, cachePolicyInherit, cachePolicyCheckInterval, cachePolicyCacheTimeout, cachePolicySyncOnDemand, cachePolicyLocalParts FROM " );
  statement.append( tableName() );
  statement.append( QLatin1String(" WHERE name = :key") );
  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), name );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of record with name"
      << name << "from table" << tableName()
      << query.lastError().text();
    return Location();
  }
  if ( !query.next() ) {
    return Location();
  }

  Location rv(
  
    query.value( 0 ).value<qint64>()
    ,
    query.value( 1 ).value<QString>()
    ,
    query.value( 2 ).value<QByteArray>()
    ,
    query.value( 3 ).value<qint64>()
    ,
    query.value( 4 ).value<qint64>()
    ,
    query.value( 5 ).value<bool>()
    ,
    query.value( 6 ).value<bool>()
    ,
    query.value( 7 ).value<int>()
    ,
    query.value( 8 ).value<int>()
    ,
    query.value( 9 ).value<bool>()
    ,
    query.value( 10 ).value<QString>()
    
  );
  if ( Private::cacheEnabled ) {
    Private::addToCache( rv );
  }
  return rv;

}


QList<Location> Location::retrieveAll()
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QList<Location>();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, remoteId, name, parentId, resourceId, subscribed, cachePolicyInherit, cachePolicyCheckInterval, cachePolicyCacheTimeout, cachePolicySyncOnDemand, cachePolicyLocalParts FROM " );
  statement.append( tableName() );
  query.prepare( statement );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of all records from table" << tableName()
      << query.lastError().text();
    return QList<Location>();
  }
  return extractResult( query );
}

QList<Location> Location::retrieveFiltered( const QString &key, const QVariant &value )
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QList<Location>();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, remoteId, name, parentId, resourceId, subscribed, cachePolicyInherit, cachePolicyCheckInterval, cachePolicyCacheTimeout, cachePolicySyncOnDemand, cachePolicyLocalParts FROM " );
  statement.append( tableName() );
  statement.append( QLatin1String(" WHERE ") );
  statement.append( key );
  statement.append( QLatin1String(" = :key") );
  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), value );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of records from table" << tableName()
      << "filtered by" << key << "=" << value
      << query.lastError().text();
    return QList<Location>();
  }
  return extractResult( query );
}

// data retrieval for referenced tables
Location Location::parent() const
{
  return Location::retrieveById( parentId() );

}
Resource Location::resource() const
{
  return Resource::retrieveById( resourceId() );

}


// data retrieval for inverse referenced tables

QList<Location> Location::children() const
{
  return Location::retrieveFiltered( Location::parentIdColumn(), id() );
}

QList<PimItem> Location::items() const
{
  return PimItem::retrieveFiltered( PimItem::locationIdColumn(), id() );
}

QList<LocationAttribute> Location::attributes() const
{
  return LocationAttribute::retrieveFiltered( LocationAttribute::locationIdColumn(), id() );
}


// data retrieval for n:m relations
QList<MimeType> Location::mimeTypes() const
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QList<MimeType>();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT " );
  
    statement.append( QLatin1String("MimeTypeTable.id" ) );
    
    statement.append( QLatin1String(", ") );
    
    statement.append( QLatin1String("MimeTypeTable.name" ) );
    
  statement.append( QLatin1String(" FROM MimeTypeTable, LocationMimeTypeRelation") );
  statement.append( QLatin1String(" WHERE LocationMimeTypeRelation.Location_id = :key") );
  statement.append( QLatin1String(" AND LocationMimeTypeRelation.MimeType_id = MimeTypeTable.id") );

  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), id() );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of records from table LocationMimeTypeRelation"
      << query.lastError().text();
    return QList<MimeType>();
  }

  return MimeType::extractResult( query );
}

// manipulate n:m relations
bool Location::relatesToMimeType( const MimeType & value ) const
{
  return Entity::relatesTo<LocationMimeTypeRelation>( id(), value.id() );
}

bool Location::relatesToMimeType( qint64 leftId, qint64 rightId )
{
  return Entity::relatesTo<LocationMimeTypeRelation>( leftId, rightId );
}

bool Location::addMimeType( const MimeType & value ) const
{
  return Entity::addToRelation<LocationMimeTypeRelation>( id(), value.id() );
}

bool Location::addMimeType( qint64 leftId, qint64 rightId )
{
  return Entity::addToRelation<LocationMimeTypeRelation>( leftId, rightId );
}

bool Location::removeMimeType( const MimeType & value ) const
{
  return Entity::removeFromRelation<LocationMimeTypeRelation>( id(), value.id() );
}

bool Location::removeMimeType( qint64 leftId, qint64 rightId )
{
  return Entity::removeFromRelation<LocationMimeTypeRelation>( leftId, rightId );
}

bool Location::clearMimeTypes() const
{
  return Entity::clearRelation<LocationMimeTypeRelation>( id() );
}

bool Location::clearMimeTypes( qint64 id )
{
  return Entity::clearRelation<LocationMimeTypeRelation>( id );
}



// data retrieval for n:m relations
QList<PimItem> Location::pimItems() const
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QList<PimItem>();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT " );
  
    statement.append( QLatin1String("PimItemTable.id" ) );
    
    statement.append( QLatin1String(", ") );
    
    statement.append( QLatin1String("PimItemTable.rev" ) );
    
    statement.append( QLatin1String(", ") );
    
    statement.append( QLatin1String("PimItemTable.remoteId" ) );
    
    statement.append( QLatin1String(", ") );
    
    statement.append( QLatin1String("PimItemTable.locationId" ) );
    
    statement.append( QLatin1String(", ") );
    
    statement.append( QLatin1String("PimItemTable.mimeTypeId" ) );
    
    statement.append( QLatin1String(", ") );
    
    statement.append( QLatin1String("PimItemTable.datetime" ) );
    
    statement.append( QLatin1String(", ") );
    
    statement.append( QLatin1String("PimItemTable.atime" ) );
    
    statement.append( QLatin1String(", ") );
    
    statement.append( QLatin1String("PimItemTable.dirty" ) );
    
    statement.append( QLatin1String(", ") );
    
    statement.append( QLatin1String("PimItemTable.size" ) );
    
  statement.append( QLatin1String(" FROM PimItemTable, LocationPimItemRelation") );
  statement.append( QLatin1String(" WHERE LocationPimItemRelation.Location_id = :key") );
  statement.append( QLatin1String(" AND LocationPimItemRelation.PimItem_id = PimItemTable.id") );

  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), id() );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of records from table LocationPimItemRelation"
      << query.lastError().text();
    return QList<PimItem>();
  }

  return PimItem::extractResult( query );
}

// manipulate n:m relations
bool Location::relatesToPimItem( const PimItem & value ) const
{
  return Entity::relatesTo<LocationPimItemRelation>( id(), value.id() );
}

bool Location::relatesToPimItem( qint64 leftId, qint64 rightId )
{
  return Entity::relatesTo<LocationPimItemRelation>( leftId, rightId );
}

bool Location::addPimItem( const PimItem & value ) const
{
  return Entity::addToRelation<LocationPimItemRelation>( id(), value.id() );
}

bool Location::addPimItem( qint64 leftId, qint64 rightId )
{
  return Entity::addToRelation<LocationPimItemRelation>( leftId, rightId );
}

bool Location::removePimItem( const PimItem & value ) const
{
  return Entity::removeFromRelation<LocationPimItemRelation>( id(), value.id() );
}

bool Location::removePimItem( qint64 leftId, qint64 rightId )
{
  return Entity::removeFromRelation<LocationPimItemRelation>( leftId, rightId );
}

bool Location::clearPimItems() const
{
  return Entity::clearRelation<LocationPimItemRelation>( id() );
}

bool Location::clearPimItems( qint64 id )
{
  return Entity::clearRelation<LocationPimItemRelation>( id );
}



// debug stream operator
QDebug & operator<<( QDebug& d, const Location& entity )
{
  d << "[Location: "
  
    << "id = " << entity.id()
    << ", "
    << "remoteId = " << entity.remoteId()
    << ", "
    << "name = " << entity.name()
    << ", "
    << "parentId = " << entity.parentId()
    << ", "
    << "resourceId = " << entity.resourceId()
    << ", "
    << "subscribed = " << entity.subscribed()
    << ", "
    << "cachePolicyInherit = " << entity.cachePolicyInherit()
    << ", "
    << "cachePolicyCheckInterval = " << entity.cachePolicyCheckInterval()
    << ", "
    << "cachePolicyCacheTimeout = " << entity.cachePolicyCacheTimeout()
    << ", "
    << "cachePolicySyncOnDemand = " << entity.cachePolicySyncOnDemand()
    << ", "
    << "cachePolicyLocalParts = " << entity.cachePolicyLocalParts()
    
    << "]";
  return d;
}

// inserting new data
bool Location::insert( qint64* insertId )
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return false;

  QStringList cols, vals;
  
  if ( d->remoteId_changed ) {
    cols.append( remoteIdColumn() );
    vals.append( QLatin1String( ":remoteId" ) );
  }
  
  if ( d->name_changed ) {
    cols.append( nameColumn() );
    vals.append( QLatin1String( ":name" ) );
  }
  
  if ( d->parentId_changed ) {
    cols.append( parentIdColumn() );
    vals.append( QLatin1String( ":parentId" ) );
  }
  
  if ( d->resourceId_changed ) {
    cols.append( resourceIdColumn() );
    vals.append( QLatin1String( ":resourceId" ) );
  }
  
  if ( d->subscribed_changed ) {
    cols.append( subscribedColumn() );
    vals.append( QLatin1String( ":subscribed" ) );
  }
  
  if ( d->cachePolicyInherit_changed ) {
    cols.append( cachePolicyInheritColumn() );
    vals.append( QLatin1String( ":cachePolicyInherit" ) );
  }
  
  if ( d->cachePolicyCheckInterval_changed ) {
    cols.append( cachePolicyCheckIntervalColumn() );
    vals.append( QLatin1String( ":cachePolicyCheckInterval" ) );
  }
  
  if ( d->cachePolicyCacheTimeout_changed ) {
    cols.append( cachePolicyCacheTimeoutColumn() );
    vals.append( QLatin1String( ":cachePolicyCacheTimeout" ) );
  }
  
  if ( d->cachePolicySyncOnDemand_changed ) {
    cols.append( cachePolicySyncOnDemandColumn() );
    vals.append( QLatin1String( ":cachePolicySyncOnDemand" ) );
  }
  
  if ( d->cachePolicyLocalParts_changed ) {
    cols.append( cachePolicyLocalPartsColumn() );
    vals.append( QLatin1String( ":cachePolicyLocalParts" ) );
  }
  
  QString statement = QString::fromLatin1("INSERT INTO LocationTable (%1) VALUES (%2)")
    .arg( cols.join( QLatin1String(",") ), vals.join( QLatin1String(",") ) );

  QSqlQuery query( db );
  query.prepare( statement );
  
  if ( d->remoteId_changed ) {
    query.bindValue( QLatin1String(":remoteId"), this->remoteId() );
  }
  
  if ( d->name_changed ) {
    query.bindValue( QLatin1String(":name"), this->name() );
  }
  
  if ( d->parentId_changed ) {
    query.bindValue( QLatin1String(":parentId"), this->parentId() );
  }
  
  if ( d->resourceId_changed ) {
    query.bindValue( QLatin1String(":resourceId"), this->resourceId() );
  }
  
  if ( d->subscribed_changed ) {
    query.bindValue( QLatin1String(":subscribed"), this->subscribed() );
  }
  
  if ( d->cachePolicyInherit_changed ) {
    query.bindValue( QLatin1String(":cachePolicyInherit"), this->cachePolicyInherit() );
  }
  
  if ( d->cachePolicyCheckInterval_changed ) {
    query.bindValue( QLatin1String(":cachePolicyCheckInterval"), this->cachePolicyCheckInterval() );
  }
  
  if ( d->cachePolicyCacheTimeout_changed ) {
    query.bindValue( QLatin1String(":cachePolicyCacheTimeout"), this->cachePolicyCacheTimeout() );
  }
  
  if ( d->cachePolicySyncOnDemand_changed ) {
    query.bindValue( QLatin1String(":cachePolicySyncOnDemand"), this->cachePolicySyncOnDemand() );
  }
  
  if ( d->cachePolicyLocalParts_changed ) {
    query.bindValue( QLatin1String(":cachePolicyLocalParts"), this->cachePolicyLocalParts() );
  }
  

  if ( !query.exec() ) {
    qDebug() << "Error during insertion into table" << tableName()
      << query.lastError().text();
    return false;
  }

  setId( DataStore::self()->lastInsertId( query ) );
  if ( insertId )
    *insertId = id();
  return true;
}

// update existing data
bool Location::update()
{
  invalidateCache();
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return false;

  QString statement = QLatin1String( "UPDATE " );
  statement += tableName();
  statement += QLatin1String( " SET " );

  QStringList cols;
  
  if ( d->remoteId_changed )
    cols.append( remoteIdColumn() + QLatin1String( " = :remoteId" ) );;
  
  if ( d->name_changed )
    cols.append( nameColumn() + QLatin1String( " = :name" ) );;
  
  if ( d->parentId_changed )
    cols.append( parentIdColumn() + QLatin1String( " = :parentId" ) );;
  
  if ( d->resourceId_changed )
    cols.append( resourceIdColumn() + QLatin1String( " = :resourceId" ) );;
  
  if ( d->subscribed_changed )
    cols.append( subscribedColumn() + QLatin1String( " = :subscribed" ) );;
  
  if ( d->cachePolicyInherit_changed )
    cols.append( cachePolicyInheritColumn() + QLatin1String( " = :cachePolicyInherit" ) );;
  
  if ( d->cachePolicyCheckInterval_changed )
    cols.append( cachePolicyCheckIntervalColumn() + QLatin1String( " = :cachePolicyCheckInterval" ) );;
  
  if ( d->cachePolicyCacheTimeout_changed )
    cols.append( cachePolicyCacheTimeoutColumn() + QLatin1String( " = :cachePolicyCacheTimeout" ) );;
  
  if ( d->cachePolicySyncOnDemand_changed )
    cols.append( cachePolicySyncOnDemandColumn() + QLatin1String( " = :cachePolicySyncOnDemand" ) );;
  
  if ( d->cachePolicyLocalParts_changed )
    cols.append( cachePolicyLocalPartsColumn() + QLatin1String( " = :cachePolicyLocalParts" ) );;
  
  statement += cols.join( QLatin1String( ", " ) );
  
  statement += QLatin1String( " WHERE id = :id" );
  

  QSqlQuery query( db );
  query.prepare( statement );
  
  if ( d->remoteId_changed ) {
    query.bindValue( QLatin1String(":remoteId"), this->remoteId() );
  }
  
  if ( d->name_changed ) {
    query.bindValue( QLatin1String(":name"), this->name() );
  }
  
  if ( d->parentId_changed ) {
    query.bindValue( QLatin1String(":parentId"), this->parentId() );
  }
  
  if ( d->resourceId_changed ) {
    query.bindValue( QLatin1String(":resourceId"), this->resourceId() );
  }
  
  if ( d->subscribed_changed ) {
    query.bindValue( QLatin1String(":subscribed"), this->subscribed() );
  }
  
  if ( d->cachePolicyInherit_changed ) {
    query.bindValue( QLatin1String(":cachePolicyInherit"), this->cachePolicyInherit() );
  }
  
  if ( d->cachePolicyCheckInterval_changed ) {
    query.bindValue( QLatin1String(":cachePolicyCheckInterval"), this->cachePolicyCheckInterval() );
  }
  
  if ( d->cachePolicyCacheTimeout_changed ) {
    query.bindValue( QLatin1String(":cachePolicyCacheTimeout"), this->cachePolicyCacheTimeout() );
  }
  
  if ( d->cachePolicySyncOnDemand_changed ) {
    query.bindValue( QLatin1String(":cachePolicySyncOnDemand"), this->cachePolicySyncOnDemand() );
  }
  
  if ( d->cachePolicyLocalParts_changed ) {
    query.bindValue( QLatin1String(":cachePolicyLocalParts"), this->cachePolicyLocalParts() );
  }
  
  query.bindValue( QLatin1String(":id"), id() );
  
  if ( !query.exec() ) {
    qDebug() << "Error during updating record with id" << id()
             << " in table" << tableName() << query.lastError().text();
    return false;
  }
  return true;
}

// delete records
bool Location::remove( const QString &column, const QVariant &value )
{
  invalidateCompleteCache();
  return Entity::remove<Location>( column, value );
}


bool Location::remove()
{
  invalidateCache();
  return Entity::remove<Location>( idColumn(), id() );
}

bool Location::remove( qint64 id )
{
  return remove( idColumn(), id );
}


// cache stuff
void Location::invalidateCache() const
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    
    Private::idCache.remove( id() );
    
    Private::nameCache.remove( name() );
    
    Private::cacheMutex.unlock();
  }
}

void Location::invalidateCompleteCache()
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    
    Private::idCache.clear();
    
    Private::nameCache.clear();
    
    Private::cacheMutex.unlock();
  }
}

void Location::enableCache( bool enable )
{
  Private::cacheEnabled = enable;
}



// private class
class MimeType::Private : public QSharedData
{
  public:
    Private() : QSharedData() {}
    Private( const Private & other ) : QSharedData( other )
    {
      name = other.name;
      name_changed = other.name_changed;
      
    }
    ~Private() {};

    QString name;
    bool name_changed;
    

    static void addToCache( const MimeType & entry );

    // cache
    static bool cacheEnabled;
    static QMutex cacheMutex;
    
    static QHash<qint64, MimeType > idCache;
    
    static QHash<QString, MimeType > nameCache;
    
};


// static members
bool MimeType::Private::cacheEnabled = false;
QMutex MimeType::Private::cacheMutex;

QHash<qint64, MimeType > MimeType::Private::idCache;

QHash<QString, MimeType > MimeType::Private::nameCache;



void MimeType::Private::addToCache( const MimeType & entry )
{
  Q_ASSERT( cacheEnabled );
  cacheMutex.lock();
  
  idCache.insert( entry.id(), entry );
  
  nameCache.insert( entry.name(), entry );
  
  cacheMutex.unlock();
}


// constructor
MimeType::MimeType() : Entity(),
  d( new Private )
{

  d->name_changed = false;

}

MimeType::MimeType(
  const QString &name
) :
  Entity(),
  d( new Private )
{

  d->name = name;
  d->name_changed = true;

}

MimeType::MimeType(
  qint64 id, const QString &name
) :
  Entity( id ),
  d( new Private )
{

  d->name = name;
  d->name_changed = true;

}
MimeType::MimeType( const MimeType & other )
  : Entity( other ), d( other.d )
{
}

// destructor
MimeType::~MimeType() {}

// assignment operator
MimeType& MimeType::operator=( const MimeType & other )
{
  if ( this != &other ) {
    d = other.d;
    setId( other.id() );
  }
  return *this;
}

// accessor methods
QString MimeType::name() const
{
  return d->name;
}

void MimeType::
setName( const QString &name )

{
  d->name = name;
  d->name_changed = true;
}



// SQL table information
QString MimeType::tableName()
{
  return QLatin1String( "MimeTypeTable" );
}

QStringList MimeType::columnNames()
{
  QStringList rv;
  
  rv.append( QLatin1String( "id" ) );
  
  rv.append( QLatin1String( "name" ) );
  
  return rv;
}

QStringList MimeType::fullColumnNames()
{
  QStringList rv;
  
  rv.append( QLatin1String( "MimeTypeTable.id" ) );
  
  rv.append( QLatin1String( "MimeTypeTable.name" ) );
  
  return rv;
}


QString MimeType::idColumn()
{
  return QLatin1String( "id" );
}

QString MimeType::idFullColumnName()
{
  return tableName() + QLatin1String( ".id" );
}

QString MimeType::nameColumn()
{
  return QLatin1String( "name" );
}

QString MimeType::nameFullColumnName()
{
  return tableName() + QLatin1String( ".name" );
}



// count records
int MimeType::count( const QString &column, const QVariant &value )
{
  return Entity::count<MimeType>( column, value );
}

// check existence

bool MimeType::exists( qint64 id )
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::idCache.contains( id ) ) {
      Private::cacheMutex.unlock();
      return true;
    }
    Private::cacheMutex.unlock();
  }
  return count( idColumn(), id ) > 0;
}

bool MimeType::exists( const QString &name )
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::nameCache.contains( name ) ) {
      Private::cacheMutex.unlock();
      return true;
    }
    Private::cacheMutex.unlock();
  }
  return count( nameColumn(), name ) > 0;
}



// result extraction
QList< MimeType > MimeType::extractResult( QSqlQuery & query )
{
  QList<MimeType> rv;
  while ( query.next() ) {
    rv.append( MimeType(
      
        query.value( 0 ).value<qint64>()
        ,
        query.value( 1 ).value<QString>()
        
    ) );
  }
  return rv;
}

// data retrieval
MimeType MimeType::retrieveById( qint64 id )
{
  
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::idCache.contains( id ) ) {
      Private::cacheMutex.unlock();
      return Private::idCache.value( id );
    }
    Private::cacheMutex.unlock();
  }
  
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return MimeType();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, name FROM " );
  statement.append( tableName() );
  statement.append( QLatin1String(" WHERE id = :key") );
  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), id );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of record with id"
      << id << "from table" << tableName()
      << query.lastError().text();
    return MimeType();
  }
  if ( !query.next() ) {
    return MimeType();
  }

  MimeType rv(
  
    query.value( 0 ).value<qint64>()
    ,
    query.value( 1 ).value<QString>()
    
  );
  if ( Private::cacheEnabled ) {
    Private::addToCache( rv );
  }
  return rv;

}

MimeType MimeType::retrieveByName( const QString &name )
{
  
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::nameCache.contains( name ) ) {
      Private::cacheMutex.unlock();
      return Private::nameCache.value( name );
    }
    Private::cacheMutex.unlock();
  }
  
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return MimeType();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, name FROM " );
  statement.append( tableName() );
  statement.append( QLatin1String(" WHERE name = :key") );
  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), name );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of record with name"
      << name << "from table" << tableName()
      << query.lastError().text();
    return MimeType();
  }
  if ( !query.next() ) {
    return MimeType();
  }

  MimeType rv(
  
    query.value( 0 ).value<qint64>()
    ,
    query.value( 1 ).value<QString>()
    
  );
  if ( Private::cacheEnabled ) {
    Private::addToCache( rv );
  }
  return rv;

}


QList<MimeType> MimeType::retrieveAll()
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QList<MimeType>();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, name FROM " );
  statement.append( tableName() );
  query.prepare( statement );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of all records from table" << tableName()
      << query.lastError().text();
    return QList<MimeType>();
  }
  return extractResult( query );
}

QList<MimeType> MimeType::retrieveFiltered( const QString &key, const QVariant &value )
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QList<MimeType>();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, name FROM " );
  statement.append( tableName() );
  statement.append( QLatin1String(" WHERE ") );
  statement.append( key );
  statement.append( QLatin1String(" = :key") );
  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), value );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of records from table" << tableName()
      << "filtered by" << key << "=" << value
      << query.lastError().text();
    return QList<MimeType>();
  }
  return extractResult( query );
}

// data retrieval for referenced tables


// data retrieval for inverse referenced tables


// debug stream operator
QDebug & operator<<( QDebug& d, const MimeType& entity )
{
  d << "[MimeType: "
  
    << "id = " << entity.id()
    << ", "
    << "name = " << entity.name()
    
    << "]";
  return d;
}

// inserting new data
bool MimeType::insert( qint64* insertId )
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return false;

  QStringList cols, vals;
  
  if ( d->name_changed ) {
    cols.append( nameColumn() );
    vals.append( QLatin1String( ":name" ) );
  }
  
  QString statement = QString::fromLatin1("INSERT INTO MimeTypeTable (%1) VALUES (%2)")
    .arg( cols.join( QLatin1String(",") ), vals.join( QLatin1String(",") ) );

  QSqlQuery query( db );
  query.prepare( statement );
  
  if ( d->name_changed ) {
    query.bindValue( QLatin1String(":name"), this->name() );
  }
  

  if ( !query.exec() ) {
    qDebug() << "Error during insertion into table" << tableName()
      << query.lastError().text();
    return false;
  }

  setId( DataStore::self()->lastInsertId( query ) );
  if ( insertId )
    *insertId = id();
  return true;
}

// update existing data
bool MimeType::update()
{
  invalidateCache();
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return false;

  QString statement = QLatin1String( "UPDATE " );
  statement += tableName();
  statement += QLatin1String( " SET " );

  QStringList cols;
  
  if ( d->name_changed )
    cols.append( nameColumn() + QLatin1String( " = :name" ) );;
  
  statement += cols.join( QLatin1String( ", " ) );
  
  statement += QLatin1String( " WHERE id = :id" );
  

  QSqlQuery query( db );
  query.prepare( statement );
  
  if ( d->name_changed ) {
    query.bindValue( QLatin1String(":name"), this->name() );
  }
  
  query.bindValue( QLatin1String(":id"), id() );
  
  if ( !query.exec() ) {
    qDebug() << "Error during updating record with id" << id()
             << " in table" << tableName() << query.lastError().text();
    return false;
  }
  return true;
}

// delete records
bool MimeType::remove( const QString &column, const QVariant &value )
{
  invalidateCompleteCache();
  return Entity::remove<MimeType>( column, value );
}


bool MimeType::remove()
{
  invalidateCache();
  return Entity::remove<MimeType>( idColumn(), id() );
}

bool MimeType::remove( qint64 id )
{
  return remove( idColumn(), id );
}


// cache stuff
void MimeType::invalidateCache() const
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    
    Private::idCache.remove( id() );
    
    Private::nameCache.remove( name() );
    
    Private::cacheMutex.unlock();
  }
}

void MimeType::invalidateCompleteCache()
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    
    Private::idCache.clear();
    
    Private::nameCache.clear();
    
    Private::cacheMutex.unlock();
  }
}

void MimeType::enableCache( bool enable )
{
  Private::cacheEnabled = enable;
}



// private class
class PimItem::Private : public QSharedData
{
  public:
    Private() : QSharedData() {}
    Private( const Private & other ) : QSharedData( other )
    {
      rev = other.rev;
      rev_changed = other.rev_changed;
      remoteId = other.remoteId;
      remoteId_changed = other.remoteId_changed;
      locationId = other.locationId;
      locationId_changed = other.locationId_changed;
      mimeTypeId = other.mimeTypeId;
      mimeTypeId_changed = other.mimeTypeId_changed;
      datetime = other.datetime;
      datetime_changed = other.datetime_changed;
      atime = other.atime;
      atime_changed = other.atime_changed;
      dirty = other.dirty;
      dirty_changed = other.dirty_changed;
      size = other.size;
      size_changed = other.size_changed;
      
    }
    ~Private() {};

    int rev;
    bool rev_changed;
    QByteArray remoteId;
    bool remoteId_changed;
    qint64 locationId;
    bool locationId_changed;
    qint64 mimeTypeId;
    bool mimeTypeId_changed;
    QDateTime datetime;
    bool datetime_changed;
    QDateTime atime;
    bool atime_changed;
    bool dirty;
    bool dirty_changed;
    qint64 size;
    bool size_changed;
    

    static void addToCache( const PimItem & entry );

    // cache
    static bool cacheEnabled;
    static QMutex cacheMutex;
    
    static QHash<qint64, PimItem > idCache;
    
};


// static members
bool PimItem::Private::cacheEnabled = false;
QMutex PimItem::Private::cacheMutex;

QHash<qint64, PimItem > PimItem::Private::idCache;



void PimItem::Private::addToCache( const PimItem & entry )
{
  Q_ASSERT( cacheEnabled );
  cacheMutex.lock();
  
  idCache.insert( entry.id(), entry );
  
  cacheMutex.unlock();
}


// constructor
PimItem::PimItem() : Entity(),
  d( new Private )
{

  d->rev_changed = false;

  d->remoteId_changed = false;

  d->locationId_changed = false;

  d->mimeTypeId_changed = false;

  d->datetime_changed = false;

  d->atime_changed = false;

  d->dirty_changed = false;

  d->size_changed = false;

}

PimItem::PimItem(
  int rev, const QByteArray &remoteId, qint64 locationId, qint64 mimeTypeId, const QDateTime &datetime, const QDateTime &atime, bool dirty, qint64 size
) :
  Entity(),
  d( new Private )
{

  d->rev = rev;
  d->rev_changed = true;

  d->remoteId = remoteId;
  d->remoteId_changed = true;

  d->locationId = locationId;
  d->locationId_changed = true;

  d->mimeTypeId = mimeTypeId;
  d->mimeTypeId_changed = true;

  d->datetime = datetime;
  d->datetime_changed = true;

  d->atime = atime;
  d->atime_changed = true;

  d->dirty = dirty;
  d->dirty_changed = true;

  d->size = size;
  d->size_changed = true;

}

PimItem::PimItem(
  qint64 id, int rev, const QByteArray &remoteId, qint64 locationId, qint64 mimeTypeId, const QDateTime &datetime, const QDateTime &atime, bool dirty, qint64 size
) :
  Entity( id ),
  d( new Private )
{

  d->rev = rev;
  d->rev_changed = true;

  d->remoteId = remoteId;
  d->remoteId_changed = true;

  d->locationId = locationId;
  d->locationId_changed = true;

  d->mimeTypeId = mimeTypeId;
  d->mimeTypeId_changed = true;

  d->datetime = datetime;
  d->datetime_changed = true;

  d->atime = atime;
  d->atime_changed = true;

  d->dirty = dirty;
  d->dirty_changed = true;

  d->size = size;
  d->size_changed = true;

}
PimItem::PimItem( const PimItem & other )
  : Entity( other ), d( other.d )
{
}

// destructor
PimItem::~PimItem() {}

// assignment operator
PimItem& PimItem::operator=( const PimItem & other )
{
  if ( this != &other ) {
    d = other.d;
    setId( other.id() );
  }
  return *this;
}

// accessor methods
int PimItem::rev() const
{
  return d->rev;
}

void PimItem::
setRev( int rev )

{
  d->rev = rev;
  d->rev_changed = true;
}

QByteArray PimItem::remoteId() const
{
  return d->remoteId;
}

void PimItem::
setRemoteId( const QByteArray &remoteId )

{
  d->remoteId = remoteId;
  d->remoteId_changed = true;
}

qint64 PimItem::locationId() const
{
  return d->locationId;
}

void PimItem::
setLocationId( qint64 locationId )

{
  d->locationId = locationId;
  d->locationId_changed = true;
}

qint64 PimItem::mimeTypeId() const
{
  return d->mimeTypeId;
}

void PimItem::
setMimeTypeId( qint64 mimeTypeId )

{
  d->mimeTypeId = mimeTypeId;
  d->mimeTypeId_changed = true;
}

QDateTime PimItem::datetime() const
{
  return d->datetime;
}

void PimItem::
setDatetime( const QDateTime &datetime )

{
  d->datetime = datetime;
  d->datetime_changed = true;
}

QDateTime PimItem::atime() const
{
  return d->atime;
}

void PimItem::
setAtime( const QDateTime &atime )

{
  d->atime = atime;
  d->atime_changed = true;
}

bool PimItem::dirty() const
{
  return d->dirty;
}

void PimItem::
setDirty( bool dirty )

{
  d->dirty = dirty;
  d->dirty_changed = true;
}

qint64 PimItem::size() const
{
  return d->size;
}

void PimItem::
setSize( qint64 size )

{
  d->size = size;
  d->size_changed = true;
}



// SQL table information
QString PimItem::tableName()
{
  return QLatin1String( "PimItemTable" );
}

QStringList PimItem::columnNames()
{
  QStringList rv;
  
  rv.append( QLatin1String( "id" ) );
  
  rv.append( QLatin1String( "rev" ) );
  
  rv.append( QLatin1String( "remoteId" ) );
  
  rv.append( QLatin1String( "locationId" ) );
  
  rv.append( QLatin1String( "mimeTypeId" ) );
  
  rv.append( QLatin1String( "datetime" ) );
  
  rv.append( QLatin1String( "atime" ) );
  
  rv.append( QLatin1String( "dirty" ) );
  
  rv.append( QLatin1String( "size" ) );
  
  return rv;
}

QStringList PimItem::fullColumnNames()
{
  QStringList rv;
  
  rv.append( QLatin1String( "PimItemTable.id" ) );
  
  rv.append( QLatin1String( "PimItemTable.rev" ) );
  
  rv.append( QLatin1String( "PimItemTable.remoteId" ) );
  
  rv.append( QLatin1String( "PimItemTable.locationId" ) );
  
  rv.append( QLatin1String( "PimItemTable.mimeTypeId" ) );
  
  rv.append( QLatin1String( "PimItemTable.datetime" ) );
  
  rv.append( QLatin1String( "PimItemTable.atime" ) );
  
  rv.append( QLatin1String( "PimItemTable.dirty" ) );
  
  rv.append( QLatin1String( "PimItemTable.size" ) );
  
  return rv;
}


QString PimItem::idColumn()
{
  return QLatin1String( "id" );
}

QString PimItem::idFullColumnName()
{
  return tableName() + QLatin1String( ".id" );
}

QString PimItem::revColumn()
{
  return QLatin1String( "rev" );
}

QString PimItem::revFullColumnName()
{
  return tableName() + QLatin1String( ".rev" );
}

QString PimItem::remoteIdColumn()
{
  return QLatin1String( "remoteId" );
}

QString PimItem::remoteIdFullColumnName()
{
  return tableName() + QLatin1String( ".remoteId" );
}

QString PimItem::locationIdColumn()
{
  return QLatin1String( "locationId" );
}

QString PimItem::locationIdFullColumnName()
{
  return tableName() + QLatin1String( ".locationId" );
}

QString PimItem::mimeTypeIdColumn()
{
  return QLatin1String( "mimeTypeId" );
}

QString PimItem::mimeTypeIdFullColumnName()
{
  return tableName() + QLatin1String( ".mimeTypeId" );
}

QString PimItem::datetimeColumn()
{
  return QLatin1String( "datetime" );
}

QString PimItem::datetimeFullColumnName()
{
  return tableName() + QLatin1String( ".datetime" );
}

QString PimItem::atimeColumn()
{
  return QLatin1String( "atime" );
}

QString PimItem::atimeFullColumnName()
{
  return tableName() + QLatin1String( ".atime" );
}

QString PimItem::dirtyColumn()
{
  return QLatin1String( "dirty" );
}

QString PimItem::dirtyFullColumnName()
{
  return tableName() + QLatin1String( ".dirty" );
}

QString PimItem::sizeColumn()
{
  return QLatin1String( "size" );
}

QString PimItem::sizeFullColumnName()
{
  return tableName() + QLatin1String( ".size" );
}



// count records
int PimItem::count( const QString &column, const QVariant &value )
{
  return Entity::count<PimItem>( column, value );
}

// check existence

bool PimItem::exists( qint64 id )
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::idCache.contains( id ) ) {
      Private::cacheMutex.unlock();
      return true;
    }
    Private::cacheMutex.unlock();
  }
  return count( idColumn(), id ) > 0;
}



// result extraction
QList< PimItem > PimItem::extractResult( QSqlQuery & query )
{
  QList<PimItem> rv;
  while ( query.next() ) {
    rv.append( PimItem(
      
        query.value( 0 ).value<qint64>()
        ,
        query.value( 1 ).value<int>()
        ,
        query.value( 2 ).value<QByteArray>()
        ,
        query.value( 3 ).value<qint64>()
        ,
        query.value( 4 ).value<qint64>()
        ,
        query.value( 5 ).value<QDateTime>()
        ,
        query.value( 6 ).value<QDateTime>()
        ,
        query.value( 7 ).value<bool>()
        ,
        query.value( 8 ).value<qint64>()
        
    ) );
  }
  return rv;
}

// data retrieval
PimItem PimItem::retrieveById( qint64 id )
{
  
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::idCache.contains( id ) ) {
      Private::cacheMutex.unlock();
      return Private::idCache.value( id );
    }
    Private::cacheMutex.unlock();
  }
  
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return PimItem();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, rev, remoteId, locationId, mimeTypeId, datetime, atime, dirty, size FROM " );
  statement.append( tableName() );
  statement.append( QLatin1String(" WHERE id = :key") );
  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), id );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of record with id"
      << id << "from table" << tableName()
      << query.lastError().text();
    return PimItem();
  }
  if ( !query.next() ) {
    return PimItem();
  }

  PimItem rv(
  
    query.value( 0 ).value<qint64>()
    ,
    query.value( 1 ).value<int>()
    ,
    query.value( 2 ).value<QByteArray>()
    ,
    query.value( 3 ).value<qint64>()
    ,
    query.value( 4 ).value<qint64>()
    ,
    query.value( 5 ).value<QDateTime>()
    ,
    query.value( 6 ).value<QDateTime>()
    ,
    query.value( 7 ).value<bool>()
    ,
    query.value( 8 ).value<qint64>()
    
  );
  if ( Private::cacheEnabled ) {
    Private::addToCache( rv );
  }
  return rv;

}



QList<PimItem> PimItem::retrieveAll()
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QList<PimItem>();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, rev, remoteId, locationId, mimeTypeId, datetime, atime, dirty, size FROM " );
  statement.append( tableName() );
  query.prepare( statement );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of all records from table" << tableName()
      << query.lastError().text();
    return QList<PimItem>();
  }
  return extractResult( query );
}

QList<PimItem> PimItem::retrieveFiltered( const QString &key, const QVariant &value )
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QList<PimItem>();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, rev, remoteId, locationId, mimeTypeId, datetime, atime, dirty, size FROM " );
  statement.append( tableName() );
  statement.append( QLatin1String(" WHERE ") );
  statement.append( key );
  statement.append( QLatin1String(" = :key") );
  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), value );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of records from table" << tableName()
      << "filtered by" << key << "=" << value
      << query.lastError().text();
    return QList<PimItem>();
  }
  return extractResult( query );
}

// data retrieval for referenced tables
Location PimItem::location() const
{
  return Location::retrieveById( locationId() );

}
MimeType PimItem::mimeType() const
{
  return MimeType::retrieveById( mimeTypeId() );

}


// data retrieval for inverse referenced tables

QList<Part> PimItem::parts() const
{
  return Part::retrieveFiltered( Part::pimItemIdColumn(), id() );
}


// data retrieval for n:m relations
QList<Flag> PimItem::flags() const
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QList<Flag>();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT " );
  
    statement.append( QLatin1String("FlagTable.id" ) );
    
    statement.append( QLatin1String(", ") );
    
    statement.append( QLatin1String("FlagTable.name" ) );
    
  statement.append( QLatin1String(" FROM FlagTable, PimItemFlagRelation") );
  statement.append( QLatin1String(" WHERE PimItemFlagRelation.PimItem_id = :key") );
  statement.append( QLatin1String(" AND PimItemFlagRelation.Flag_id = FlagTable.id") );

  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), id() );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of records from table PimItemFlagRelation"
      << query.lastError().text();
    return QList<Flag>();
  }

  return Flag::extractResult( query );
}

// manipulate n:m relations
bool PimItem::relatesToFlag( const Flag & value ) const
{
  return Entity::relatesTo<PimItemFlagRelation>( id(), value.id() );
}

bool PimItem::relatesToFlag( qint64 leftId, qint64 rightId )
{
  return Entity::relatesTo<PimItemFlagRelation>( leftId, rightId );
}

bool PimItem::addFlag( const Flag & value ) const
{
  return Entity::addToRelation<PimItemFlagRelation>( id(), value.id() );
}

bool PimItem::addFlag( qint64 leftId, qint64 rightId )
{
  return Entity::addToRelation<PimItemFlagRelation>( leftId, rightId );
}

bool PimItem::removeFlag( const Flag & value ) const
{
  return Entity::removeFromRelation<PimItemFlagRelation>( id(), value.id() );
}

bool PimItem::removeFlag( qint64 leftId, qint64 rightId )
{
  return Entity::removeFromRelation<PimItemFlagRelation>( leftId, rightId );
}

bool PimItem::clearFlags() const
{
  return Entity::clearRelation<PimItemFlagRelation>( id() );
}

bool PimItem::clearFlags( qint64 id )
{
  return Entity::clearRelation<PimItemFlagRelation>( id );
}



// debug stream operator
QDebug & operator<<( QDebug& d, const PimItem& entity )
{
  d << "[PimItem: "
  
    << "id = " << entity.id()
    << ", "
    << "rev = " << entity.rev()
    << ", "
    << "remoteId = " << entity.remoteId()
    << ", "
    << "locationId = " << entity.locationId()
    << ", "
    << "mimeTypeId = " << entity.mimeTypeId()
    << ", "
    << "datetime = " << entity.datetime()
    << ", "
    << "atime = " << entity.atime()
    << ", "
    << "dirty = " << entity.dirty()
    << ", "
    << "size = " << entity.size()
    
    << "]";
  return d;
}

// inserting new data
bool PimItem::insert( qint64* insertId )
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return false;

  QStringList cols, vals;
  
  if ( d->rev_changed ) {
    cols.append( revColumn() );
    vals.append( QLatin1String( ":rev" ) );
  }
  
  if ( d->remoteId_changed ) {
    cols.append( remoteIdColumn() );
    vals.append( QLatin1String( ":remoteId" ) );
  }
  
  if ( d->locationId_changed ) {
    cols.append( locationIdColumn() );
    vals.append( QLatin1String( ":locationId" ) );
  }
  
  if ( d->mimeTypeId_changed ) {
    cols.append( mimeTypeIdColumn() );
    vals.append( QLatin1String( ":mimeTypeId" ) );
  }
  
  if ( d->datetime_changed ) {
    cols.append( datetimeColumn() );
    vals.append( QLatin1String( ":datetime" ) );
  }
  
  if ( d->atime_changed ) {
    cols.append( atimeColumn() );
    vals.append( QLatin1String( ":atime" ) );
  }
  
  if ( d->dirty_changed ) {
    cols.append( dirtyColumn() );
    vals.append( QLatin1String( ":dirty" ) );
  }
  
  if ( d->size_changed ) {
    cols.append( sizeColumn() );
    vals.append( QLatin1String( ":size" ) );
  }
  
  QString statement = QString::fromLatin1("INSERT INTO PimItemTable (%1) VALUES (%2)")
    .arg( cols.join( QLatin1String(",") ), vals.join( QLatin1String(",") ) );

  QSqlQuery query( db );
  query.prepare( statement );
  
  if ( d->rev_changed ) {
    query.bindValue( QLatin1String(":rev"), this->rev() );
  }
  
  if ( d->remoteId_changed ) {
    query.bindValue( QLatin1String(":remoteId"), this->remoteId() );
  }
  
  if ( d->locationId_changed ) {
    query.bindValue( QLatin1String(":locationId"), this->locationId() );
  }
  
  if ( d->mimeTypeId_changed ) {
    query.bindValue( QLatin1String(":mimeTypeId"), this->mimeTypeId() );
  }
  
  if ( d->datetime_changed ) {
    query.bindValue( QLatin1String(":datetime"), this->datetime() );
  }
  
  if ( d->atime_changed ) {
    query.bindValue( QLatin1String(":atime"), this->atime() );
  }
  
  if ( d->dirty_changed ) {
    query.bindValue( QLatin1String(":dirty"), this->dirty() );
  }
  
  if ( d->size_changed ) {
    query.bindValue( QLatin1String(":size"), this->size() );
  }
  

  if ( !query.exec() ) {
    qDebug() << "Error during insertion into table" << tableName()
      << query.lastError().text();
    return false;
  }

  setId( DataStore::self()->lastInsertId( query ) );
  if ( insertId )
    *insertId = id();
  return true;
}

// update existing data
bool PimItem::update()
{
  invalidateCache();
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return false;

  QString statement = QLatin1String( "UPDATE " );
  statement += tableName();
  statement += QLatin1String( " SET " );

  QStringList cols;
  
  if ( d->rev_changed )
    cols.append( revColumn() + QLatin1String( " = :rev" ) );;
  
  if ( d->remoteId_changed )
    cols.append( remoteIdColumn() + QLatin1String( " = :remoteId" ) );;
  
  if ( d->locationId_changed )
    cols.append( locationIdColumn() + QLatin1String( " = :locationId" ) );;
  
  if ( d->mimeTypeId_changed )
    cols.append( mimeTypeIdColumn() + QLatin1String( " = :mimeTypeId" ) );;
  
  if ( d->datetime_changed )
    cols.append( datetimeColumn() + QLatin1String( " = :datetime" ) );;
  
  if ( d->atime_changed )
    cols.append( atimeColumn() + QLatin1String( " = :atime" ) );;
  
  if ( d->dirty_changed )
    cols.append( dirtyColumn() + QLatin1String( " = :dirty" ) );;
  
  if ( d->size_changed )
    cols.append( sizeColumn() + QLatin1String( " = :size" ) );;
  
  statement += cols.join( QLatin1String( ", " ) );
  
  statement += QLatin1String( " WHERE id = :id" );
  

  QSqlQuery query( db );
  query.prepare( statement );
  
  if ( d->rev_changed ) {
    query.bindValue( QLatin1String(":rev"), this->rev() );
  }
  
  if ( d->remoteId_changed ) {
    query.bindValue( QLatin1String(":remoteId"), this->remoteId() );
  }
  
  if ( d->locationId_changed ) {
    query.bindValue( QLatin1String(":locationId"), this->locationId() );
  }
  
  if ( d->mimeTypeId_changed ) {
    query.bindValue( QLatin1String(":mimeTypeId"), this->mimeTypeId() );
  }
  
  if ( d->datetime_changed ) {
    query.bindValue( QLatin1String(":datetime"), this->datetime() );
  }
  
  if ( d->atime_changed ) {
    query.bindValue( QLatin1String(":atime"), this->atime() );
  }
  
  if ( d->dirty_changed ) {
    query.bindValue( QLatin1String(":dirty"), this->dirty() );
  }
  
  if ( d->size_changed ) {
    query.bindValue( QLatin1String(":size"), this->size() );
  }
  
  query.bindValue( QLatin1String(":id"), id() );
  
  if ( !query.exec() ) {
    qDebug() << "Error during updating record with id" << id()
             << " in table" << tableName() << query.lastError().text();
    return false;
  }
  return true;
}

// delete records
bool PimItem::remove( const QString &column, const QVariant &value )
{
  invalidateCompleteCache();
  return Entity::remove<PimItem>( column, value );
}


bool PimItem::remove()
{
  invalidateCache();
  return Entity::remove<PimItem>( idColumn(), id() );
}

bool PimItem::remove( qint64 id )
{
  return remove( idColumn(), id );
}


// cache stuff
void PimItem::invalidateCache() const
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    
    Private::idCache.remove( id() );
    
    Private::cacheMutex.unlock();
  }
}

void PimItem::invalidateCompleteCache()
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    
    Private::idCache.clear();
    
    Private::cacheMutex.unlock();
  }
}

void PimItem::enableCache( bool enable )
{
  Private::cacheEnabled = enable;
}



// private class
class Flag::Private : public QSharedData
{
  public:
    Private() : QSharedData() {}
    Private( const Private & other ) : QSharedData( other )
    {
      name = other.name;
      name_changed = other.name_changed;
      
    }
    ~Private() {};

    QString name;
    bool name_changed;
    

    static void addToCache( const Flag & entry );

    // cache
    static bool cacheEnabled;
    static QMutex cacheMutex;
    
    static QHash<qint64, Flag > idCache;
    
    static QHash<QString, Flag > nameCache;
    
};


// static members
bool Flag::Private::cacheEnabled = false;
QMutex Flag::Private::cacheMutex;

QHash<qint64, Flag > Flag::Private::idCache;

QHash<QString, Flag > Flag::Private::nameCache;



void Flag::Private::addToCache( const Flag & entry )
{
  Q_ASSERT( cacheEnabled );
  cacheMutex.lock();
  
  idCache.insert( entry.id(), entry );
  
  nameCache.insert( entry.name(), entry );
  
  cacheMutex.unlock();
}


// constructor
Flag::Flag() : Entity(),
  d( new Private )
{

  d->name_changed = false;

}

Flag::Flag(
  const QString &name
) :
  Entity(),
  d( new Private )
{

  d->name = name;
  d->name_changed = true;

}

Flag::Flag(
  qint64 id, const QString &name
) :
  Entity( id ),
  d( new Private )
{

  d->name = name;
  d->name_changed = true;

}
Flag::Flag( const Flag & other )
  : Entity( other ), d( other.d )
{
}

// destructor
Flag::~Flag() {}

// assignment operator
Flag& Flag::operator=( const Flag & other )
{
  if ( this != &other ) {
    d = other.d;
    setId( other.id() );
  }
  return *this;
}

// accessor methods
QString Flag::name() const
{
  return d->name;
}

void Flag::
setName( const QString &name )

{
  d->name = name;
  d->name_changed = true;
}



// SQL table information
QString Flag::tableName()
{
  return QLatin1String( "FlagTable" );
}

QStringList Flag::columnNames()
{
  QStringList rv;
  
  rv.append( QLatin1String( "id" ) );
  
  rv.append( QLatin1String( "name" ) );
  
  return rv;
}

QStringList Flag::fullColumnNames()
{
  QStringList rv;
  
  rv.append( QLatin1String( "FlagTable.id" ) );
  
  rv.append( QLatin1String( "FlagTable.name" ) );
  
  return rv;
}


QString Flag::idColumn()
{
  return QLatin1String( "id" );
}

QString Flag::idFullColumnName()
{
  return tableName() + QLatin1String( ".id" );
}

QString Flag::nameColumn()
{
  return QLatin1String( "name" );
}

QString Flag::nameFullColumnName()
{
  return tableName() + QLatin1String( ".name" );
}



// count records
int Flag::count( const QString &column, const QVariant &value )
{
  return Entity::count<Flag>( column, value );
}

// check existence

bool Flag::exists( qint64 id )
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::idCache.contains( id ) ) {
      Private::cacheMutex.unlock();
      return true;
    }
    Private::cacheMutex.unlock();
  }
  return count( idColumn(), id ) > 0;
}

bool Flag::exists( const QString &name )
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::nameCache.contains( name ) ) {
      Private::cacheMutex.unlock();
      return true;
    }
    Private::cacheMutex.unlock();
  }
  return count( nameColumn(), name ) > 0;
}



// result extraction
QList< Flag > Flag::extractResult( QSqlQuery & query )
{
  QList<Flag> rv;
  while ( query.next() ) {
    rv.append( Flag(
      
        query.value( 0 ).value<qint64>()
        ,
        query.value( 1 ).value<QString>()
        
    ) );
  }
  return rv;
}

// data retrieval
Flag Flag::retrieveById( qint64 id )
{
  
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::idCache.contains( id ) ) {
      Private::cacheMutex.unlock();
      return Private::idCache.value( id );
    }
    Private::cacheMutex.unlock();
  }
  
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return Flag();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, name FROM " );
  statement.append( tableName() );
  statement.append( QLatin1String(" WHERE id = :key") );
  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), id );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of record with id"
      << id << "from table" << tableName()
      << query.lastError().text();
    return Flag();
  }
  if ( !query.next() ) {
    return Flag();
  }

  Flag rv(
  
    query.value( 0 ).value<qint64>()
    ,
    query.value( 1 ).value<QString>()
    
  );
  if ( Private::cacheEnabled ) {
    Private::addToCache( rv );
  }
  return rv;

}

Flag Flag::retrieveByName( const QString &name )
{
  
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::nameCache.contains( name ) ) {
      Private::cacheMutex.unlock();
      return Private::nameCache.value( name );
    }
    Private::cacheMutex.unlock();
  }
  
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return Flag();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, name FROM " );
  statement.append( tableName() );
  statement.append( QLatin1String(" WHERE name = :key") );
  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), name );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of record with name"
      << name << "from table" << tableName()
      << query.lastError().text();
    return Flag();
  }
  if ( !query.next() ) {
    return Flag();
  }

  Flag rv(
  
    query.value( 0 ).value<qint64>()
    ,
    query.value( 1 ).value<QString>()
    
  );
  if ( Private::cacheEnabled ) {
    Private::addToCache( rv );
  }
  return rv;

}


QList<Flag> Flag::retrieveAll()
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QList<Flag>();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, name FROM " );
  statement.append( tableName() );
  query.prepare( statement );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of all records from table" << tableName()
      << query.lastError().text();
    return QList<Flag>();
  }
  return extractResult( query );
}

QList<Flag> Flag::retrieveFiltered( const QString &key, const QVariant &value )
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QList<Flag>();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, name FROM " );
  statement.append( tableName() );
  statement.append( QLatin1String(" WHERE ") );
  statement.append( key );
  statement.append( QLatin1String(" = :key") );
  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), value );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of records from table" << tableName()
      << "filtered by" << key << "=" << value
      << query.lastError().text();
    return QList<Flag>();
  }
  return extractResult( query );
}

// data retrieval for referenced tables


// data retrieval for inverse referenced tables


// debug stream operator
QDebug & operator<<( QDebug& d, const Flag& entity )
{
  d << "[Flag: "
  
    << "id = " << entity.id()
    << ", "
    << "name = " << entity.name()
    
    << "]";
  return d;
}

// inserting new data
bool Flag::insert( qint64* insertId )
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return false;

  QStringList cols, vals;
  
  if ( d->name_changed ) {
    cols.append( nameColumn() );
    vals.append( QLatin1String( ":name" ) );
  }
  
  QString statement = QString::fromLatin1("INSERT INTO FlagTable (%1) VALUES (%2)")
    .arg( cols.join( QLatin1String(",") ), vals.join( QLatin1String(",") ) );

  QSqlQuery query( db );
  query.prepare( statement );
  
  if ( d->name_changed ) {
    query.bindValue( QLatin1String(":name"), this->name() );
  }
  

  if ( !query.exec() ) {
    qDebug() << "Error during insertion into table" << tableName()
      << query.lastError().text();
    return false;
  }

  setId( DataStore::self()->lastInsertId( query ) );
  if ( insertId )
    *insertId = id();
  return true;
}

// update existing data
bool Flag::update()
{
  invalidateCache();
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return false;

  QString statement = QLatin1String( "UPDATE " );
  statement += tableName();
  statement += QLatin1String( " SET " );

  QStringList cols;
  
  if ( d->name_changed )
    cols.append( nameColumn() + QLatin1String( " = :name" ) );;
  
  statement += cols.join( QLatin1String( ", " ) );
  
  statement += QLatin1String( " WHERE id = :id" );
  

  QSqlQuery query( db );
  query.prepare( statement );
  
  if ( d->name_changed ) {
    query.bindValue( QLatin1String(":name"), this->name() );
  }
  
  query.bindValue( QLatin1String(":id"), id() );
  
  if ( !query.exec() ) {
    qDebug() << "Error during updating record with id" << id()
             << " in table" << tableName() << query.lastError().text();
    return false;
  }
  return true;
}

// delete records
bool Flag::remove( const QString &column, const QVariant &value )
{
  invalidateCompleteCache();
  return Entity::remove<Flag>( column, value );
}


bool Flag::remove()
{
  invalidateCache();
  return Entity::remove<Flag>( idColumn(), id() );
}

bool Flag::remove( qint64 id )
{
  return remove( idColumn(), id );
}


// cache stuff
void Flag::invalidateCache() const
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    
    Private::idCache.remove( id() );
    
    Private::nameCache.remove( name() );
    
    Private::cacheMutex.unlock();
  }
}

void Flag::invalidateCompleteCache()
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    
    Private::idCache.clear();
    
    Private::nameCache.clear();
    
    Private::cacheMutex.unlock();
  }
}

void Flag::enableCache( bool enable )
{
  Private::cacheEnabled = enable;
}



// private class
class Part::Private : public QSharedData
{
  public:
    Private() : QSharedData() {}
    Private( const Private & other ) : QSharedData( other )
    {
      pimItemId = other.pimItemId;
      pimItemId_changed = other.pimItemId_changed;
      name = other.name;
      name_changed = other.name_changed;
      data = other.data;
      data_changed = other.data_changed;
      datasize = other.datasize;
      datasize_changed = other.datasize_changed;
      version = other.version;
      version_changed = other.version_changed;
      
    }
    ~Private() {};

    qint64 pimItemId;
    bool pimItemId_changed;
    QString name;
    bool name_changed;
    QByteArray data;
    bool data_changed;
    int datasize;
    bool datasize_changed;
    int version;
    bool version_changed;
    

    static void addToCache( const Part & entry );

    // cache
    static bool cacheEnabled;
    static QMutex cacheMutex;
    
    static QHash<qint64, Part > idCache;
    
    static QHash<QString, Part > nameCache;
    
};


// static members
bool Part::Private::cacheEnabled = false;
QMutex Part::Private::cacheMutex;

QHash<qint64, Part > Part::Private::idCache;

QHash<QString, Part > Part::Private::nameCache;



void Part::Private::addToCache( const Part & entry )
{
  Q_ASSERT( cacheEnabled );
  cacheMutex.lock();
  
  idCache.insert( entry.id(), entry );
  
  nameCache.insert( entry.name(), entry );
  
  cacheMutex.unlock();
}


// constructor
Part::Part() : Entity(),
  d( new Private )
{

  d->pimItemId_changed = false;

  d->name_changed = false;

  d->data_changed = false;

  d->datasize_changed = false;

  d->version_changed = false;

}

Part::Part(
  qint64 pimItemId, const QString &name, const QByteArray &data, int datasize, int version
) :
  Entity(),
  d( new Private )
{

  d->pimItemId = pimItemId;
  d->pimItemId_changed = true;

  d->name = name;
  d->name_changed = true;

  d->data = data;
  d->data_changed = true;

  d->datasize = datasize;
  d->datasize_changed = true;

  d->version = version;
  d->version_changed = true;

}

Part::Part(
  qint64 id, qint64 pimItemId, const QString &name, const QByteArray &data, int datasize, int version
) :
  Entity( id ),
  d( new Private )
{

  d->pimItemId = pimItemId;
  d->pimItemId_changed = true;

  d->name = name;
  d->name_changed = true;

  d->data = data;
  d->data_changed = true;

  d->datasize = datasize;
  d->datasize_changed = true;

  d->version = version;
  d->version_changed = true;

}
Part::Part( const Part & other )
  : Entity( other ), d( other.d )
{
}

// destructor
Part::~Part() {}

// assignment operator
Part& Part::operator=( const Part & other )
{
  if ( this != &other ) {
    d = other.d;
    setId( other.id() );
  }
  return *this;
}

// accessor methods
qint64 Part::pimItemId() const
{
  return d->pimItemId;
}

void Part::
setPimItemId( qint64 pimItemId )

{
  d->pimItemId = pimItemId;
  d->pimItemId_changed = true;
}

QString Part::name() const
{
  return d->name;
}

void Part::
setName( const QString &name )

{
  d->name = name;
  d->name_changed = true;
}

QByteArray Part::data() const
{
  return d->data;
}

void Part::
setData( const QByteArray &data )

{
  d->data = data;
  d->data_changed = true;
}

int Part::datasize() const
{
  return d->datasize;
}

void Part::
setDatasize( int datasize )

{
  d->datasize = datasize;
  d->datasize_changed = true;
}

int Part::version() const
{
  return d->version;
}

void Part::
setVersion( int version )

{
  d->version = version;
  d->version_changed = true;
}



// SQL table information
QString Part::tableName()
{
  return QLatin1String( "PartTable" );
}

QStringList Part::columnNames()
{
  QStringList rv;
  
  rv.append( QLatin1String( "id" ) );
  
  rv.append( QLatin1String( "pimItemId" ) );
  
  rv.append( QLatin1String( "name" ) );
  
  rv.append( QLatin1String( "data" ) );
  
  rv.append( QLatin1String( "datasize" ) );
  
  rv.append( QLatin1String( "version" ) );
  
  return rv;
}

QStringList Part::fullColumnNames()
{
  QStringList rv;
  
  rv.append( QLatin1String( "PartTable.id" ) );
  
  rv.append( QLatin1String( "PartTable.pimItemId" ) );
  
  rv.append( QLatin1String( "PartTable.name" ) );
  
  rv.append( QLatin1String( "PartTable.data" ) );
  
  rv.append( QLatin1String( "PartTable.datasize" ) );
  
  rv.append( QLatin1String( "PartTable.version" ) );
  
  return rv;
}


QString Part::idColumn()
{
  return QLatin1String( "id" );
}

QString Part::idFullColumnName()
{
  return tableName() + QLatin1String( ".id" );
}

QString Part::pimItemIdColumn()
{
  return QLatin1String( "pimItemId" );
}

QString Part::pimItemIdFullColumnName()
{
  return tableName() + QLatin1String( ".pimItemId" );
}

QString Part::nameColumn()
{
  return QLatin1String( "name" );
}

QString Part::nameFullColumnName()
{
  return tableName() + QLatin1String( ".name" );
}

QString Part::dataColumn()
{
  return QLatin1String( "data" );
}

QString Part::dataFullColumnName()
{
  return tableName() + QLatin1String( ".data" );
}

QString Part::datasizeColumn()
{
  return QLatin1String( "datasize" );
}

QString Part::datasizeFullColumnName()
{
  return tableName() + QLatin1String( ".datasize" );
}

QString Part::versionColumn()
{
  return QLatin1String( "version" );
}

QString Part::versionFullColumnName()
{
  return tableName() + QLatin1String( ".version" );
}



// count records
int Part::count( const QString &column, const QVariant &value )
{
  return Entity::count<Part>( column, value );
}

// check existence

bool Part::exists( qint64 id )
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::idCache.contains( id ) ) {
      Private::cacheMutex.unlock();
      return true;
    }
    Private::cacheMutex.unlock();
  }
  return count( idColumn(), id ) > 0;
}

bool Part::exists( const QString &name )
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::nameCache.contains( name ) ) {
      Private::cacheMutex.unlock();
      return true;
    }
    Private::cacheMutex.unlock();
  }
  return count( nameColumn(), name ) > 0;
}



// result extraction
QList< Part > Part::extractResult( QSqlQuery & query )
{
  QList<Part> rv;
  while ( query.next() ) {
    rv.append( Part(
      
        query.value( 0 ).value<qint64>()
        ,
        query.value( 1 ).value<qint64>()
        ,
        query.value( 2 ).value<QString>()
        ,
        query.value( 3 ).value<QByteArray>()
        ,
        query.value( 4 ).value<int>()
        ,
        query.value( 5 ).value<int>()
        
    ) );
  }
  return rv;
}

// data retrieval
Part Part::retrieveById( qint64 id )
{
  
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::idCache.contains( id ) ) {
      Private::cacheMutex.unlock();
      return Private::idCache.value( id );
    }
    Private::cacheMutex.unlock();
  }
  
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return Part();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, pimItemId, name, data, datasize, version FROM " );
  statement.append( tableName() );
  statement.append( QLatin1String(" WHERE id = :key") );
  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), id );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of record with id"
      << id << "from table" << tableName()
      << query.lastError().text();
    return Part();
  }
  if ( !query.next() ) {
    return Part();
  }

  Part rv(
  
    query.value( 0 ).value<qint64>()
    ,
    query.value( 1 ).value<qint64>()
    ,
    query.value( 2 ).value<QString>()
    ,
    query.value( 3 ).value<QByteArray>()
    ,
    query.value( 4 ).value<int>()
    ,
    query.value( 5 ).value<int>()
    
  );
  if ( Private::cacheEnabled ) {
    Private::addToCache( rv );
  }
  return rv;

}

Part Part::retrieveByName( const QString &name )
{
  
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::nameCache.contains( name ) ) {
      Private::cacheMutex.unlock();
      return Private::nameCache.value( name );
    }
    Private::cacheMutex.unlock();
  }
  
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return Part();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, pimItemId, name, data, datasize, version FROM " );
  statement.append( tableName() );
  statement.append( QLatin1String(" WHERE name = :key") );
  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), name );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of record with name"
      << name << "from table" << tableName()
      << query.lastError().text();
    return Part();
  }
  if ( !query.next() ) {
    return Part();
  }

  Part rv(
  
    query.value( 0 ).value<qint64>()
    ,
    query.value( 1 ).value<qint64>()
    ,
    query.value( 2 ).value<QString>()
    ,
    query.value( 3 ).value<QByteArray>()
    ,
    query.value( 4 ).value<int>()
    ,
    query.value( 5 ).value<int>()
    
  );
  if ( Private::cacheEnabled ) {
    Private::addToCache( rv );
  }
  return rv;

}


QList<Part> Part::retrieveAll()
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QList<Part>();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, pimItemId, name, data, datasize, version FROM " );
  statement.append( tableName() );
  query.prepare( statement );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of all records from table" << tableName()
      << query.lastError().text();
    return QList<Part>();
  }
  return extractResult( query );
}

QList<Part> Part::retrieveFiltered( const QString &key, const QVariant &value )
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QList<Part>();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, pimItemId, name, data, datasize, version FROM " );
  statement.append( tableName() );
  statement.append( QLatin1String(" WHERE ") );
  statement.append( key );
  statement.append( QLatin1String(" = :key") );
  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), value );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of records from table" << tableName()
      << "filtered by" << key << "=" << value
      << query.lastError().text();
    return QList<Part>();
  }
  return extractResult( query );
}

// data retrieval for referenced tables
PimItem Part::pimItem() const
{
  return PimItem::retrieveById( pimItemId() );

}


// data retrieval for inverse referenced tables


// debug stream operator
QDebug & operator<<( QDebug& d, const Part& entity )
{
  d << "[Part: "
  
    << "id = " << entity.id()
    << ", "
    << "pimItemId = " << entity.pimItemId()
    << ", "
    << "name = " << entity.name()
    << ", "
    << "data = " << entity.data()
    << ", "
    << "datasize = " << entity.datasize()
    << ", "
    << "version = " << entity.version()
    
    << "]";
  return d;
}

// inserting new data
bool Part::insert( qint64* insertId )
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return false;

  QStringList cols, vals;
  
  if ( d->pimItemId_changed ) {
    cols.append( pimItemIdColumn() );
    vals.append( QLatin1String( ":pimItemId" ) );
  }
  
  if ( d->name_changed ) {
    cols.append( nameColumn() );
    vals.append( QLatin1String( ":name" ) );
  }
  
  if ( d->data_changed ) {
    cols.append( dataColumn() );
    vals.append( QLatin1String( ":data" ) );
  }
  
  if ( d->datasize_changed ) {
    cols.append( datasizeColumn() );
    vals.append( QLatin1String( ":datasize" ) );
  }
  
  if ( d->version_changed ) {
    cols.append( versionColumn() );
    vals.append( QLatin1String( ":version" ) );
  }
  
  QString statement = QString::fromLatin1("INSERT INTO PartTable (%1) VALUES (%2)")
    .arg( cols.join( QLatin1String(",") ), vals.join( QLatin1String(",") ) );

  QSqlQuery query( db );
  query.prepare( statement );
  
  if ( d->pimItemId_changed ) {
    query.bindValue( QLatin1String(":pimItemId"), this->pimItemId() );
  }
  
  if ( d->name_changed ) {
    query.bindValue( QLatin1String(":name"), this->name() );
  }
  
  if ( d->data_changed ) {
    query.bindValue( QLatin1String(":data"), this->data() );
  }
  
  if ( d->datasize_changed ) {
    query.bindValue( QLatin1String(":datasize"), this->datasize() );
  }
  
  if ( d->version_changed ) {
    query.bindValue( QLatin1String(":version"), this->version() );
  }
  

  if ( !query.exec() ) {
    qDebug() << "Error during insertion into table" << tableName()
      << query.lastError().text();
    return false;
  }

  setId( DataStore::self()->lastInsertId( query ) );
  if ( insertId )
    *insertId = id();
  return true;
}

// update existing data
bool Part::update()
{
  invalidateCache();
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return false;

  QString statement = QLatin1String( "UPDATE " );
  statement += tableName();
  statement += QLatin1String( " SET " );

  QStringList cols;
  
  if ( d->pimItemId_changed )
    cols.append( pimItemIdColumn() + QLatin1String( " = :pimItemId" ) );;
  
  if ( d->name_changed )
    cols.append( nameColumn() + QLatin1String( " = :name" ) );;
  
  if ( d->data_changed )
    cols.append( dataColumn() + QLatin1String( " = :data" ) );;
  
  if ( d->datasize_changed )
    cols.append( datasizeColumn() + QLatin1String( " = :datasize" ) );;
  
  if ( d->version_changed )
    cols.append( versionColumn() + QLatin1String( " = :version" ) );;
  
  statement += cols.join( QLatin1String( ", " ) );
  
  statement += QLatin1String( " WHERE id = :id" );
  

  QSqlQuery query( db );
  query.prepare( statement );
  
  if ( d->pimItemId_changed ) {
    query.bindValue( QLatin1String(":pimItemId"), this->pimItemId() );
  }
  
  if ( d->name_changed ) {
    query.bindValue( QLatin1String(":name"), this->name() );
  }
  
  if ( d->data_changed ) {
    query.bindValue( QLatin1String(":data"), this->data() );
  }
  
  if ( d->datasize_changed ) {
    query.bindValue( QLatin1String(":datasize"), this->datasize() );
  }
  
  if ( d->version_changed ) {
    query.bindValue( QLatin1String(":version"), this->version() );
  }
  
  query.bindValue( QLatin1String(":id"), id() );
  
  if ( !query.exec() ) {
    qDebug() << "Error during updating record with id" << id()
             << " in table" << tableName() << query.lastError().text();
    return false;
  }
  return true;
}

// delete records
bool Part::remove( const QString &column, const QVariant &value )
{
  invalidateCompleteCache();
  return Entity::remove<Part>( column, value );
}


bool Part::remove()
{
  invalidateCache();
  return Entity::remove<Part>( idColumn(), id() );
}

bool Part::remove( qint64 id )
{
  return remove( idColumn(), id );
}


// cache stuff
void Part::invalidateCache() const
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    
    Private::idCache.remove( id() );
    
    Private::nameCache.remove( name() );
    
    Private::cacheMutex.unlock();
  }
}

void Part::invalidateCompleteCache()
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    
    Private::idCache.clear();
    
    Private::nameCache.clear();
    
    Private::cacheMutex.unlock();
  }
}

void Part::enableCache( bool enable )
{
  Private::cacheEnabled = enable;
}



// private class
class LocationAttribute::Private : public QSharedData
{
  public:
    Private() : QSharedData() {}
    Private( const Private & other ) : QSharedData( other )
    {
      locationId = other.locationId;
      locationId_changed = other.locationId_changed;
      type = other.type;
      type_changed = other.type_changed;
      value = other.value;
      value_changed = other.value_changed;
      
    }
    ~Private() {};

    qint64 locationId;
    bool locationId_changed;
    QByteArray type;
    bool type_changed;
    QByteArray value;
    bool value_changed;
    

    static void addToCache( const LocationAttribute & entry );

    // cache
    static bool cacheEnabled;
    static QMutex cacheMutex;
    
    static QHash<qint64, LocationAttribute > idCache;
    
};


// static members
bool LocationAttribute::Private::cacheEnabled = false;
QMutex LocationAttribute::Private::cacheMutex;

QHash<qint64, LocationAttribute > LocationAttribute::Private::idCache;



void LocationAttribute::Private::addToCache( const LocationAttribute & entry )
{
  Q_ASSERT( cacheEnabled );
  cacheMutex.lock();
  
  idCache.insert( entry.id(), entry );
  
  cacheMutex.unlock();
}


// constructor
LocationAttribute::LocationAttribute() : Entity(),
  d( new Private )
{

  d->locationId_changed = false;

  d->type_changed = false;

  d->value_changed = false;

}

LocationAttribute::LocationAttribute(
  qint64 locationId, const QByteArray &type, const QByteArray &value
) :
  Entity(),
  d( new Private )
{

  d->locationId = locationId;
  d->locationId_changed = true;

  d->type = type;
  d->type_changed = true;

  d->value = value;
  d->value_changed = true;

}

LocationAttribute::LocationAttribute(
  qint64 id, qint64 locationId, const QByteArray &type, const QByteArray &value
) :
  Entity( id ),
  d( new Private )
{

  d->locationId = locationId;
  d->locationId_changed = true;

  d->type = type;
  d->type_changed = true;

  d->value = value;
  d->value_changed = true;

}
LocationAttribute::LocationAttribute( const LocationAttribute & other )
  : Entity( other ), d( other.d )
{
}

// destructor
LocationAttribute::~LocationAttribute() {}

// assignment operator
LocationAttribute& LocationAttribute::operator=( const LocationAttribute & other )
{
  if ( this != &other ) {
    d = other.d;
    setId( other.id() );
  }
  return *this;
}

// accessor methods
qint64 LocationAttribute::locationId() const
{
  return d->locationId;
}

void LocationAttribute::
setLocationId( qint64 locationId )

{
  d->locationId = locationId;
  d->locationId_changed = true;
}

QByteArray LocationAttribute::type() const
{
  return d->type;
}

void LocationAttribute::
setType( const QByteArray &type )

{
  d->type = type;
  d->type_changed = true;
}

QByteArray LocationAttribute::value() const
{
  return d->value;
}

void LocationAttribute::
setValue( const QByteArray &value )

{
  d->value = value;
  d->value_changed = true;
}



// SQL table information
QString LocationAttribute::tableName()
{
  return QLatin1String( "LocationAttributeTable" );
}

QStringList LocationAttribute::columnNames()
{
  QStringList rv;
  
  rv.append( QLatin1String( "id" ) );
  
  rv.append( QLatin1String( "locationId" ) );
  
  rv.append( QLatin1String( "type" ) );
  
  rv.append( QLatin1String( "value" ) );
  
  return rv;
}

QStringList LocationAttribute::fullColumnNames()
{
  QStringList rv;
  
  rv.append( QLatin1String( "LocationAttributeTable.id" ) );
  
  rv.append( QLatin1String( "LocationAttributeTable.locationId" ) );
  
  rv.append( QLatin1String( "LocationAttributeTable.type" ) );
  
  rv.append( QLatin1String( "LocationAttributeTable.value" ) );
  
  return rv;
}


QString LocationAttribute::idColumn()
{
  return QLatin1String( "id" );
}

QString LocationAttribute::idFullColumnName()
{
  return tableName() + QLatin1String( ".id" );
}

QString LocationAttribute::locationIdColumn()
{
  return QLatin1String( "locationId" );
}

QString LocationAttribute::locationIdFullColumnName()
{
  return tableName() + QLatin1String( ".locationId" );
}

QString LocationAttribute::typeColumn()
{
  return QLatin1String( "type" );
}

QString LocationAttribute::typeFullColumnName()
{
  return tableName() + QLatin1String( ".type" );
}

QString LocationAttribute::valueColumn()
{
  return QLatin1String( "value" );
}

QString LocationAttribute::valueFullColumnName()
{
  return tableName() + QLatin1String( ".value" );
}



// count records
int LocationAttribute::count( const QString &column, const QVariant &value )
{
  return Entity::count<LocationAttribute>( column, value );
}

// check existence

bool LocationAttribute::exists( qint64 id )
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::idCache.contains( id ) ) {
      Private::cacheMutex.unlock();
      return true;
    }
    Private::cacheMutex.unlock();
  }
  return count( idColumn(), id ) > 0;
}



// result extraction
QList< LocationAttribute > LocationAttribute::extractResult( QSqlQuery & query )
{
  QList<LocationAttribute> rv;
  while ( query.next() ) {
    rv.append( LocationAttribute(
      
        query.value( 0 ).value<qint64>()
        ,
        query.value( 1 ).value<qint64>()
        ,
        query.value( 2 ).value<QByteArray>()
        ,
        query.value( 3 ).value<QByteArray>()
        
    ) );
  }
  return rv;
}

// data retrieval
LocationAttribute LocationAttribute::retrieveById( qint64 id )
{
  
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    if ( Private::idCache.contains( id ) ) {
      Private::cacheMutex.unlock();
      return Private::idCache.value( id );
    }
    Private::cacheMutex.unlock();
  }
  
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return LocationAttribute();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, locationId, type, value FROM " );
  statement.append( tableName() );
  statement.append( QLatin1String(" WHERE id = :key") );
  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), id );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of record with id"
      << id << "from table" << tableName()
      << query.lastError().text();
    return LocationAttribute();
  }
  if ( !query.next() ) {
    return LocationAttribute();
  }

  LocationAttribute rv(
  
    query.value( 0 ).value<qint64>()
    ,
    query.value( 1 ).value<qint64>()
    ,
    query.value( 2 ).value<QByteArray>()
    ,
    query.value( 3 ).value<QByteArray>()
    
  );
  if ( Private::cacheEnabled ) {
    Private::addToCache( rv );
  }
  return rv;

}



QList<LocationAttribute> LocationAttribute::retrieveAll()
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QList<LocationAttribute>();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, locationId, type, value FROM " );
  statement.append( tableName() );
  query.prepare( statement );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of all records from table" << tableName()
      << query.lastError().text();
    return QList<LocationAttribute>();
  }
  return extractResult( query );
}

QList<LocationAttribute> LocationAttribute::retrieveFiltered( const QString &key, const QVariant &value )
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return QList<LocationAttribute>();

  QSqlQuery query( db );
  QString statement = QLatin1String( "SELECT id, locationId, type, value FROM " );
  statement.append( tableName() );
  statement.append( QLatin1String(" WHERE ") );
  statement.append( key );
  statement.append( QLatin1String(" = :key") );
  query.prepare( statement );
  query.bindValue( QLatin1String(":key"), value );
  if ( !query.exec() ) {
    qDebug() << "Error during selection of records from table" << tableName()
      << "filtered by" << key << "=" << value
      << query.lastError().text();
    return QList<LocationAttribute>();
  }
  return extractResult( query );
}

// data retrieval for referenced tables
Location LocationAttribute::location() const
{
  return Location::retrieveById( locationId() );

}


// data retrieval for inverse referenced tables


// debug stream operator
QDebug & operator<<( QDebug& d, const LocationAttribute& entity )
{
  d << "[LocationAttribute: "
  
    << "id = " << entity.id()
    << ", "
    << "locationId = " << entity.locationId()
    << ", "
    << "type = " << entity.type()
    << ", "
    << "value = " << entity.value()
    
    << "]";
  return d;
}

// inserting new data
bool LocationAttribute::insert( qint64* insertId )
{
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return false;

  QStringList cols, vals;
  
  if ( d->locationId_changed ) {
    cols.append( locationIdColumn() );
    vals.append( QLatin1String( ":locationId" ) );
  }
  
  if ( d->type_changed ) {
    cols.append( typeColumn() );
    vals.append( QLatin1String( ":type" ) );
  }
  
  if ( d->value_changed ) {
    cols.append( valueColumn() );
    vals.append( QLatin1String( ":value" ) );
  }
  
  QString statement = QString::fromLatin1("INSERT INTO LocationAttributeTable (%1) VALUES (%2)")
    .arg( cols.join( QLatin1String(",") ), vals.join( QLatin1String(",") ) );

  QSqlQuery query( db );
  query.prepare( statement );
  
  if ( d->locationId_changed ) {
    query.bindValue( QLatin1String(":locationId"), this->locationId() );
  }
  
  if ( d->type_changed ) {
    query.bindValue( QLatin1String(":type"), this->type() );
  }
  
  if ( d->value_changed ) {
    query.bindValue( QLatin1String(":value"), this->value() );
  }
  

  if ( !query.exec() ) {
    qDebug() << "Error during insertion into table" << tableName()
      << query.lastError().text();
    return false;
  }

  setId( DataStore::self()->lastInsertId( query ) );
  if ( insertId )
    *insertId = id();
  return true;
}

// update existing data
bool LocationAttribute::update()
{
  invalidateCache();
  QSqlDatabase db = DataStore::self()->database();
  if ( !db.isOpen() )
    return false;

  QString statement = QLatin1String( "UPDATE " );
  statement += tableName();
  statement += QLatin1String( " SET " );

  QStringList cols;
  
  if ( d->locationId_changed )
    cols.append( locationIdColumn() + QLatin1String( " = :locationId" ) );;
  
  if ( d->type_changed )
    cols.append( typeColumn() + QLatin1String( " = :type" ) );;
  
  if ( d->value_changed )
    cols.append( valueColumn() + QLatin1String( " = :value" ) );;
  
  statement += cols.join( QLatin1String( ", " ) );
  
  statement += QLatin1String( " WHERE id = :id" );
  

  QSqlQuery query( db );
  query.prepare( statement );
  
  if ( d->locationId_changed ) {
    query.bindValue( QLatin1String(":locationId"), this->locationId() );
  }
  
  if ( d->type_changed ) {
    query.bindValue( QLatin1String(":type"), this->type() );
  }
  
  if ( d->value_changed ) {
    query.bindValue( QLatin1String(":value"), this->value() );
  }
  
  query.bindValue( QLatin1String(":id"), id() );
  
  if ( !query.exec() ) {
    qDebug() << "Error during updating record with id" << id()
             << " in table" << tableName() << query.lastError().text();
    return false;
  }
  return true;
}

// delete records
bool LocationAttribute::remove( const QString &column, const QVariant &value )
{
  invalidateCompleteCache();
  return Entity::remove<LocationAttribute>( column, value );
}


bool LocationAttribute::remove()
{
  invalidateCache();
  return Entity::remove<LocationAttribute>( idColumn(), id() );
}

bool LocationAttribute::remove( qint64 id )
{
  return remove( idColumn(), id );
}


// cache stuff
void LocationAttribute::invalidateCache() const
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    
    Private::idCache.remove( id() );
    
    Private::cacheMutex.unlock();
  }
}

void LocationAttribute::invalidateCompleteCache()
{
  if ( Private::cacheEnabled ) {
    Private::cacheMutex.lock();
    
    Private::idCache.clear();
    
    Private::cacheMutex.unlock();
  }
}

void LocationAttribute::enableCache( bool enable )
{
  Private::cacheEnabled = enable;
}



// SQL table information
QString PimItemFlagRelation::tableName()
{
  return QLatin1String( "PimItemFlagRelation" );
}

QString PimItemFlagRelation::leftColumn()
{
  return QLatin1String( "PimItem_id" );
}

QString PimItemFlagRelation::leftFullColumnName()
{
  return tableName() + QLatin1String( "." ) + leftColumn();
}

QString PimItemFlagRelation::rightColumn()
{
  return QLatin1String( "Flag_id" );
}

QString PimItemFlagRelation::rightFullColumnName()
{
  return tableName() + QLatin1String( "." ) + rightColumn();
}


// SQL table information
QString LocationMimeTypeRelation::tableName()
{
  return QLatin1String( "LocationMimeTypeRelation" );
}

QString LocationMimeTypeRelation::leftColumn()
{
  return QLatin1String( "Location_id" );
}

QString LocationMimeTypeRelation::leftFullColumnName()
{
  return tableName() + QLatin1String( "." ) + leftColumn();
}

QString LocationMimeTypeRelation::rightColumn()
{
  return QLatin1String( "MimeType_id" );
}

QString LocationMimeTypeRelation::rightFullColumnName()
{
  return tableName() + QLatin1String( "." ) + rightColumn();
}


// SQL table information
QString LocationPimItemRelation::tableName()
{
  return QLatin1String( "LocationPimItemRelation" );
}

QString LocationPimItemRelation::leftColumn()
{
  return QLatin1String( "Location_id" );
}

QString LocationPimItemRelation::leftFullColumnName()
{
  return tableName() + QLatin1String( "." ) + leftColumn();
}

QString LocationPimItemRelation::rightColumn()
{
  return QLatin1String( "PimItem_id" );
}

QString LocationPimItemRelation::rightFullColumnName()
{
  return tableName() + QLatin1String( "." ) + rightColumn();
}
